/**
 * Copyright 2007 SpringSource Inc.
 */

package com.springsource.json.parser;

/**
 * Signals an exception during parsing of JSON structure.<p/>
 * 
 * This class is threadsafe.
 * 
 * @author Andy Clement
 * @since 1.0
 */
public class InternalParseException extends RuntimeException {

    private static final long serialVersionUID = -1858207019089158397L;

    /**
     * @inheritDoc
     */
    public InternalParseException(String message) {
        super(message);
    }

    /**
     * @inheritDoc
     */
    public InternalParseException(Throwable cause) {
        super(cause);
    }

    /**
     * @inheritDoc
     */
    public InternalParseException(String message, Throwable cause) {
        super(message, cause);
    }

}
