/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.parser;

import java.util.List;

import com.springsource.json.parser.CollectionNode;
import com.springsource.json.parser.Node;

/**
 * A ListNode is a node that holds a list of child nodes.
 * 
 * Implementations of this interface must be thread safe.
 * 
 * @author Glyn Normington
 * @author Andy Clement
 * @since 1.0
 */
public interface ListNode extends CollectionNode {

    /**
     * Get the nodes in the list.
     * 
     * @return the nodes in the list
     */
    List<Node> getNodes();

}
