/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.parser;

import java.util.Set;

import com.springsource.json.parser.CollectionNode;
import com.springsource.json.parser.Node;

/**
 * A MapNode contains a keyed collection of nodes.
 * 
 * Implementations of this interface must be thread safe.
 * 
 * @author Glyn Normington
 * @author Andy Clement
 * @since 1.0
 */
public interface MapNode extends CollectionNode {

    /**
     * Get the node with the given key.
     * 
     * @param key the key of the required node
     * @return the required node or null if the key was not found
     */
    Node getNode(String key);

    /**
     * Get the set of keys in the collection
     * 
     * @return the set of keys
     */
    Set<String> getKeys();

}
