/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.parser;

import com.springsource.json.parser.Node;
import com.springsource.json.parser.ScalarNodeType;

/**
 * A ScalarNode contains a single value.
 * 
 * Implementations of this interface must be thread safe.
 * 
 * @author Glyn Normington
 * @author Andy Clement
 * @since 1.0
 */
public interface ScalarNode extends Node {

    /**
     * Get the value of this node.
     * 
     * @param <T> the type of the value of this node
     * @return the value of this node
     */
    <T> T getValue();

    /**
     * Get the type of the node.
     * 
     * @return the type of the node
     */
    ScalarNodeType getType();

}
