/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.parser.internal;

import java.util.List;

import com.springsource.json.parser.Node;
import com.springsource.json.parser.ScalarNode;
import com.springsource.json.parser.ScalarNodeType;

/**
 * This class is thread safe.
 * 
 * @author Glyn Normington
 * @since 1.0
 */
public abstract class AbstractScalarNode extends AbstractNode implements ScalarNode {

    private final ScalarNodeType scalarType;

    public AbstractScalarNode(Node parent, ScalarNodeType scalarNodeType) {
        super(parent);
        this.scalarType = scalarNodeType;
    }

    public ScalarNodeType getType() {
        return this.scalarType;
    }

    public Node getNode(List<String> path) {
        Node result = null;
        if (path.isEmpty()) {
            result = this;
        }
        return result;
    }

    public boolean addNode(List<String> path, Node newNode) {
        return false;
    }

    @Override
    public String toString() {
        return this.getValue().toString();
    }

}
