/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.parser.internal;

import com.springsource.json.parser.Node;
import com.springsource.json.parser.ScalarNode;
import com.springsource.json.parser.ScalarNodeType;

/**
 * Represents a boolean scalar node.
 * 
 * This class is thread safe.
 * 
 * @author Andy Clement
 * @since 1.0
 */
public final class StandardBooleanNode extends AbstractScalarNode implements ScalarNode {

    private final boolean value;

    public StandardBooleanNode(Node parent, boolean value) {
        super(parent, ScalarNodeType.Boolean);
        this.value = value;
    }

    @SuppressWarnings("unchecked")
    public Boolean getValue() {
        return this.value;
    }

    @Override
    public String toString() {
        return Boolean.toString(this.value);
    }

}
