/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.parser.internal;

import com.springsource.json.parser.Node;
import com.springsource.json.parser.ScalarNode;
import com.springsource.json.parser.ScalarNodeType;
import com.springsource.json.parser.internal.AbstractScalarNode;

/**
 * Represents a null scalar node.
 * 
 * This class is thread safe.
 * 
 * @author Andy Clement
 * @since 1.0
 */
public final class StandardNullNode extends AbstractScalarNode implements ScalarNode {

    public StandardNullNode(Node parent) {
        super(parent, ScalarNodeType.Null);
    }

    @SuppressWarnings("unchecked")
    public Object getValue() {
        return null;
    }

    @Override
    public String toString() {
        return "null";
    }

}
