/*
 * Copyright 2007-2008 SpringSource Inc.
 */

package com.springsource.json.validation;

/**
 * Implemented by custom format checkers
 * 
 * @author Andy Clement
 * @since 1.0
 */
public interface FormatChecker {

    /**
     * return the identifier for the format for which the format checker should be called. For example 'version'
     */
    String getFormat();

    /**
     * return true if the format of the data is as expected, otherwise return false
     */
    boolean isFormatOK(Object data);

}
