/*
 Copyright (c) 2008 SpringSource.com
 */
package com.springsource.json.writer;
/**
 * 
 * JSONException a RuntimeException thrown by any of the JSONWriter operations.
 * The standard implemention on json.org throws check exceptions.
 * <p />
 *
 * <strong>Concurrent Semantics</strong><br />
 *
 * JSONException is thread safe
 *
 * @author Paul Kuzan
 * @since 1.0
 */
public class JSONException extends RuntimeException {

    private static final long serialVersionUID = -7261377853447728037L;

    private Throwable cause;

    /**
     * Constructs a JSONException with an explanatory message.
     * 
     * @param message Detail about the reason for the exception.
     */
    public JSONException(String message) {
        super(message);
    }

    public JSONException(Throwable t) {
        super(t.getMessage());
        this.cause = t;
    }

    public Throwable getCause() {
        return this.cause;
    }
}
