/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.concurrent.core;

import java.util.concurrent.ExecutorService;

/**
 * Extension to {@link ExecutorService} that provides access to metrics about the <code>Executor</code>.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br />
 * 
 * Semantics defined in {@link ExecutorService} and {@link ExecutorServiceStatistics}.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
public interface ServerExecutorService extends ExecutorService, ExecutorServiceStatistics {

   
}
