/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.concurrent.core.queue;

/**
 * {@link BlockingDeque} that is backed by a backport-util-concurrent {@link LinkedBlockingDeque}.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br />
 * 
 * Threadsafe.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
final class LinkedBlockingDeque<T> extends BackportConcurrentBackedBlockingDeque<T> {

    public LinkedBlockingDeque() {
        super(new edu.emory.mathcs.backport.java.util.concurrent.LinkedBlockingDeque());
    }

    public LinkedBlockingDeque(int capacity) {
        super(new edu.emory.mathcs.backport.java.util.concurrent.LinkedBlockingDeque(capacity));
    }
}
