/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.config.core.internal.validate;

import org.antlr.runtime.BaseRecognizer;
import org.antlr.runtime.BitSet;
import org.antlr.runtime.DFA;
import org.antlr.runtime.IntStream;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.Parser;
import org.antlr.runtime.ParserRuleReturnScope;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.Token;
import org.antlr.runtime.TokenStream;
import org.antlr.runtime.tree.CommonTreeAdaptor;
import org.antlr.runtime.tree.RewriteEarlyExitException;
import org.antlr.runtime.tree.RewriteRuleSubtreeStream;
import org.antlr.runtime.tree.RewriteRuleTokenStream;
import org.antlr.runtime.tree.TreeAdaptor;

@SuppressWarnings("all") public class EngineConfigPointSchemaParser extends Parser {

    public static final String[] tokenNames = new String[] { "<invalid>", "<EOR>", "<DOWN>", "<UP>", "ConfigPointSchema", "MAPSCHEMA",
        "MAPLETSCHEMA", "LISTSCHEMA", "KEY", "STRINGSCHEMA", "ANYSTRING", "ENUM", "INTEGER", "INTEGERRANGE", "INTGE", "INTG", "INTLE", "INTL",
        "SIGNED", "NEGATIVE", "POSITIVE", "VERSION", "VERSIONRANGE", "VERSIONVALUE", "VERGE", "VERG", "VERLE", "VERL", "IDENTIFIER", "ALPHA",
        "DIGIT", "NUMBER", "COMMENT", "LINE_COMMENT", "WS", "':'", "'{'", "','", "'}'", "'['", "']'", "'String'", "'string'", "'Enumeration'",
        "'enumeration'", "'Int'", "'int'", "'-'", "'('", "')'", "'versionNumber'", "'VersionNumber'", "'.'" };

    public static final int ANYSTRING = 10;

    public static final int VERG = 25;

    public static final int WS = 34;

    public static final int NUMBER = 31;

    public static final int ALPHA = 29;

    public static final int COMMENT = 32;

    public static final int LINE_COMMENT = 33;

    public static final int NEGATIVE = 19;

    public static final int INTEGERRANGE = 13;

    public static final int ConfigPointSchema = 4;

    public static final int MAPSCHEMA = 5;

    public static final int VERSIONRANGE = 22;

    public static final int VERLE = 26;

    public static final int INTEGER = 12;

    public static final int STRINGSCHEMA = 9;

    public static final int INTLE = 16;

    public static final int EOF = -1;

    public static final int KEY = 8;

    public static final int INTL = 17;

    public static final int MAPLETSCHEMA = 6;

    public static final int VERSION = 21;

    public static final int INTG = 15;

    public static final int LISTSCHEMA = 7;

    public static final int SIGNED = 18;

    public static final int DIGIT = 30;

    public static final int IDENTIFIER = 28;

    public static final int POSITIVE = 20;

    public static final int INTGE = 14;

    public static final int VERGE = 24;

    public static final int VERL = 27;

    public static final int VERSIONVALUE = 23;

    public static final int ENUM = 11;

    public EngineConfigPointSchemaParser(TokenStream input) {
        super(input);
    }

    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }

    public TreeAdaptor getTreeAdaptor() {
        return this.adaptor;
    }

    public String[] getTokenNames() {
        return tokenNames;
    }

    public String getGrammarFileName() {
        return "/Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g";
    }

    public void recoverFromMismatchedSet(IntStream input, RecognitionException e, BitSet follow) throws RecognitionException {
        throw e;
    }

    public static class configPointSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start configPointSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:56:1:
    // configPointSchema : IDENTIFIER ':' configurationSchema EOF -> ^( ConfigPointSchema IDENTIFIER configurationSchema
    // ) ;
    public final configPointSchema_return configPointSchema() throws RecognitionException {
        configPointSchema_return retval = new configPointSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER1 = null;
        Token char_literal2 = null;
        Token EOF4 = null;
        configurationSchema_return configurationSchema3 = null;

        RewriteRuleTokenStream stream_35 = new RewriteRuleTokenStream(this.adaptor, "token 35");
        RewriteRuleTokenStream stream_IDENTIFIER = new RewriteRuleTokenStream(this.adaptor, "token IDENTIFIER");
        RewriteRuleTokenStream stream_EOF = new RewriteRuleTokenStream(this.adaptor, "token EOF");
        RewriteRuleSubtreeStream stream_configurationSchema = new RewriteRuleSubtreeStream(this.adaptor, "rule configurationSchema");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:57:2:
            // ( IDENTIFIER ':' configurationSchema EOF -> ^( ConfigPointSchema IDENTIFIER configurationSchema ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:57:4:
            // IDENTIFIER ':' configurationSchema EOF
            {
                IDENTIFIER1 = (Token) this.input.LT(1);
                match(this.input, IDENTIFIER, FOLLOW_IDENTIFIER_in_configPointSchema176);
                stream_IDENTIFIER.add(IDENTIFIER1);

                char_literal2 = (Token) this.input.LT(1);
                match(this.input, 35, FOLLOW_35_in_configPointSchema178);
                stream_35.add(char_literal2);

                pushFollow(FOLLOW_configurationSchema_in_configPointSchema180);
                configurationSchema3 = configurationSchema();
                this._fsp--;

                stream_configurationSchema.add(configurationSchema3.getTree());
                EOF4 = (Token) this.input.LT(1);
                match(this.input, EOF, FOLLOW_EOF_in_configPointSchema182);
                stream_EOF.add(EOF4);

                // AST REWRITE
                // elements: IDENTIFIER, configurationSchema
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 57:43: -> ^( ConfigPointSchema IDENTIFIER configurationSchema )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:57:46:
                    // ^( ConfigPointSchema IDENTIFIER configurationSchema )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(ConfigPointSchema, "ConfigPointSchema"), root_1);

                        this.adaptor.addChild(root_1, stream_IDENTIFIER.next());
                        this.adaptor.addChild(root_1, stream_configurationSchema.next());

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end configPointSchema

    public static class configurationSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start configurationSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:60:1:
    // configurationSchema : ( mapSchema | listSchema );
    public final configurationSchema_return configurationSchema() throws RecognitionException {
        configurationSchema_return retval = new configurationSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        mapSchema_return mapSchema5 = null;

        listSchema_return listSchema6 = null;

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:61:2:
            // ( mapSchema | listSchema )
            int alt1 = 2;
            int LA1_0 = this.input.LA(1);

            if (LA1_0 == 36) {
                alt1 = 1;
            } else if (LA1_0 == 39) {
                alt1 = 2;
            } else {
                NoViableAltException nvae = new NoViableAltException("60:1: configurationSchema : ( mapSchema | listSchema );", 1, 0, this.input);

                throw nvae;
            }
            switch (alt1) {
                case 1:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:61:4:
                    // mapSchema
                {
                    root_0 = (Object) this.adaptor.nil();

                    pushFollow(FOLLOW_mapSchema_in_configurationSchema207);
                    mapSchema5 = mapSchema();
                    this._fsp--;

                    this.adaptor.addChild(root_0, mapSchema5.getTree());

                }
                    break;
                case 2:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:61:16:
                    // listSchema
                {
                    root_0 = (Object) this.adaptor.nil();

                    pushFollow(FOLLOW_listSchema_in_configurationSchema211);
                    listSchema6 = listSchema();
                    this._fsp--;

                    this.adaptor.addChild(root_0, listSchema6.getTree());

                }
                    break;

            }
            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end configurationSchema

    public static class mapSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start mapSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:64:1:
    // mapSchema : '{' mapletSchema ( ',' mapletSchema )* '}' -> ^( MAPSCHEMA ( mapletSchema )+ ) ;
    public final mapSchema_return mapSchema() throws RecognitionException {
        mapSchema_return retval = new mapSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal7 = null;
        Token char_literal9 = null;
        Token char_literal11 = null;
        mapletSchema_return mapletSchema8 = null;

        mapletSchema_return mapletSchema10 = null;

        RewriteRuleTokenStream stream_37 = new RewriteRuleTokenStream(this.adaptor, "token 37");
        RewriteRuleTokenStream stream_38 = new RewriteRuleTokenStream(this.adaptor, "token 38");
        RewriteRuleTokenStream stream_36 = new RewriteRuleTokenStream(this.adaptor, "token 36");
        RewriteRuleSubtreeStream stream_mapletSchema = new RewriteRuleSubtreeStream(this.adaptor, "rule mapletSchema");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:65:2:
            // ( '{' mapletSchema ( ',' mapletSchema )* '}' -> ^( MAPSCHEMA ( mapletSchema )+ ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:65:4:
            // '{' mapletSchema ( ',' mapletSchema )* '}'
            {
                char_literal7 = (Token) this.input.LT(1);
                match(this.input, 36, FOLLOW_36_in_mapSchema223);
                stream_36.add(char_literal7);

                pushFollow(FOLLOW_mapletSchema_in_mapSchema225);
                mapletSchema8 = mapletSchema();
                this._fsp--;

                stream_mapletSchema.add(mapletSchema8.getTree());
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:65:21:
                // ( ',' mapletSchema )*
                loop2: do {
                    int alt2 = 2;
                    int LA2_0 = this.input.LA(1);

                    if (LA2_0 == 37) {
                        alt2 = 1;
                    }

                    switch (alt2) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:65:23:
                            // ',' mapletSchema
                        {
                            char_literal9 = (Token) this.input.LT(1);
                            match(this.input, 37, FOLLOW_37_in_mapSchema229);
                            stream_37.add(char_literal9);

                            pushFollow(FOLLOW_mapletSchema_in_mapSchema231);
                            mapletSchema10 = mapletSchema();
                            this._fsp--;

                            stream_mapletSchema.add(mapletSchema10.getTree());

                        }
                            break;

                        default:
                            break loop2;
                    }
                } while (true);

                char_literal11 = (Token) this.input.LT(1);
                match(this.input, 38, FOLLOW_38_in_mapSchema236);
                stream_38.add(char_literal11);

                // AST REWRITE
                // elements: mapletSchema
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 65:47: -> ^( MAPSCHEMA ( mapletSchema )+ )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:65:50:
                    // ^( MAPSCHEMA ( mapletSchema )+ )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(MAPSCHEMA, "MAPSCHEMA"), root_1);

                        if (!stream_mapletSchema.hasNext()) {
                            throw new RewriteEarlyExitException();
                        }
                        while (stream_mapletSchema.hasNext()) {
                            this.adaptor.addChild(root_1, stream_mapletSchema.next());

                        }
                        stream_mapletSchema.reset();

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end mapSchema

    public static class mapletSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start mapletSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:68:1:
    // mapletSchema : key ':' valueSchema -> ^( MAPLETSCHEMA key valueSchema ) ;
    public final mapletSchema_return mapletSchema() throws RecognitionException {
        mapletSchema_return retval = new mapletSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal13 = null;
        key_return key12 = null;

        valueSchema_return valueSchema14 = null;

        RewriteRuleTokenStream stream_35 = new RewriteRuleTokenStream(this.adaptor, "token 35");
        RewriteRuleSubtreeStream stream_key = new RewriteRuleSubtreeStream(this.adaptor, "rule key");
        RewriteRuleSubtreeStream stream_valueSchema = new RewriteRuleSubtreeStream(this.adaptor, "rule valueSchema");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:68:14:
            // ( key ':' valueSchema -> ^( MAPLETSCHEMA key valueSchema ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:68:16:
            // key ':' valueSchema
            {
                pushFollow(FOLLOW_key_in_mapletSchema257);
                key12 = key();
                this._fsp--;

                stream_key.add(key12.getTree());
                char_literal13 = (Token) this.input.LT(1);
                match(this.input, 35, FOLLOW_35_in_mapletSchema259);
                stream_35.add(char_literal13);

                pushFollow(FOLLOW_valueSchema_in_mapletSchema261);
                valueSchema14 = valueSchema();
                this._fsp--;

                stream_valueSchema.add(valueSchema14.getTree());

                // AST REWRITE
                // elements: valueSchema, key
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 68:36: -> ^( MAPLETSCHEMA key valueSchema )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:68:39:
                    // ^( MAPLETSCHEMA key valueSchema )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(MAPLETSCHEMA, "MAPLETSCHEMA"), root_1);

                        this.adaptor.addChild(root_1, stream_key.next());
                        this.adaptor.addChild(root_1, stream_valueSchema.next());

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end mapletSchema

    public static class valueSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start valueSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:71:1:
    // valueSchema : ( stringSchema | configurationSchema );
    public final valueSchema_return valueSchema() throws RecognitionException {
        valueSchema_return retval = new valueSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        stringSchema_return stringSchema15 = null;

        configurationSchema_return configurationSchema16 = null;

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:72:2:
            // ( stringSchema | configurationSchema )
            int alt3 = 2;
            switch (this.input.LA(1)) {
                case 41:
                case 42:
                case 43:
                case 44:
                case 45:
                case 46:
                case 48:
                case 50:
                case 51: {
                    alt3 = 1;
                }
                    break;
                case 39: {
                    int LA3_2 = this.input.LA(2);

                    if (LA3_2 == NUMBER || LA3_2 == 47) {
                        alt3 = 1;
                    } else if (LA3_2 == 36 || LA3_2 == 39 || LA3_2 >= 41 && LA3_2 <= 46 || LA3_2 == 48 || LA3_2 >= 50 && LA3_2 <= 51) {
                        alt3 = 2;
                    } else {
                        NoViableAltException nvae = new NoViableAltException("71:1: valueSchema : ( stringSchema | configurationSchema );", 3, 2,
                            this.input);

                        throw nvae;
                    }
                }
                    break;
                case 36: {
                    alt3 = 2;
                }
                    break;
                default:
                    NoViableAltException nvae = new NoViableAltException("71:1: valueSchema : ( stringSchema | configurationSchema );", 3, 0,
                        this.input);

                    throw nvae;
            }

            switch (alt3) {
                case 1:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:72:4:
                    // stringSchema
                {
                    root_0 = (Object) this.adaptor.nil();

                    pushFollow(FOLLOW_stringSchema_in_valueSchema284);
                    stringSchema15 = stringSchema();
                    this._fsp--;

                    this.adaptor.addChild(root_0, stringSchema15.getTree());

                }
                    break;
                case 2:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:72:19:
                    // configurationSchema
                {
                    root_0 = (Object) this.adaptor.nil();

                    pushFollow(FOLLOW_configurationSchema_in_valueSchema288);
                    configurationSchema16 = configurationSchema();
                    this._fsp--;

                    this.adaptor.addChild(root_0, configurationSchema16.getTree());

                }
                    break;

            }
            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end valueSchema

    public static class listSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start listSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:76:1:
    // listSchema : '[' valueSchema ']' -> ^( LISTSCHEMA valueSchema ) ;
    public final listSchema_return listSchema() throws RecognitionException {
        listSchema_return retval = new listSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal17 = null;
        Token char_literal19 = null;
        valueSchema_return valueSchema18 = null;

        RewriteRuleTokenStream stream_40 = new RewriteRuleTokenStream(this.adaptor, "token 40");
        RewriteRuleTokenStream stream_39 = new RewriteRuleTokenStream(this.adaptor, "token 39");
        RewriteRuleSubtreeStream stream_valueSchema = new RewriteRuleSubtreeStream(this.adaptor, "rule valueSchema");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:76:12:
            // ( '[' valueSchema ']' -> ^( LISTSCHEMA valueSchema ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:76:15:
            // '[' valueSchema ']'
            {
                char_literal17 = (Token) this.input.LT(1);
                match(this.input, 39, FOLLOW_39_in_listSchema300);
                stream_39.add(char_literal17);

                pushFollow(FOLLOW_valueSchema_in_listSchema302);
                valueSchema18 = valueSchema();
                this._fsp--;

                stream_valueSchema.add(valueSchema18.getTree());
                char_literal19 = (Token) this.input.LT(1);
                match(this.input, 40, FOLLOW_40_in_listSchema304);
                stream_40.add(char_literal19);

                // AST REWRITE
                // elements: valueSchema
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 76:35: -> ^( LISTSCHEMA valueSchema )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:76:38:
                    // ^( LISTSCHEMA valueSchema )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(LISTSCHEMA, "LISTSCHEMA"), root_1);

                        this.adaptor.addChild(root_1, stream_valueSchema.next());

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end listSchema

    public static class key_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start key
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:79:1:
    // key : IDENTIFIER -> ^( KEY IDENTIFIER ) ;
    public final key_return key() throws RecognitionException {
        key_return retval = new key_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER20 = null;

        RewriteRuleTokenStream stream_IDENTIFIER = new RewriteRuleTokenStream(this.adaptor, "token IDENTIFIER");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:79:5:
            // ( IDENTIFIER -> ^( KEY IDENTIFIER ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:79:8:
            // IDENTIFIER
            {
                IDENTIFIER20 = (Token) this.input.LT(1);
                match(this.input, IDENTIFIER, FOLLOW_IDENTIFIER_in_key326);
                stream_IDENTIFIER.add(IDENTIFIER20);

                // AST REWRITE
                // elements: IDENTIFIER
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 79:19: -> ^( KEY IDENTIFIER )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:79:22:
                    // ^( KEY IDENTIFIER )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(KEY, "KEY"), root_1);

                        this.adaptor.addChild(root_1, stream_IDENTIFIER.next());

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end key

    public static class stringSchema_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start stringSchema
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:1:
    // stringSchema : ( anyString | enumeration | integer | integerRange | version | versionRange ) -> ^( STRINGSCHEMA (
    // anyString )? ( enumeration )? ( integer )? ( integerRange )? ( version )? ( versionRange )? ) ;
    public final stringSchema_return stringSchema() throws RecognitionException {
        stringSchema_return retval = new stringSchema_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        anyString_return anyString21 = null;

        enumeration_return enumeration22 = null;

        integer_return integer23 = null;

        integerRange_return integerRange24 = null;

        version_return version25 = null;

        versionRange_return versionRange26 = null;

        RewriteRuleSubtreeStream stream_anyString = new RewriteRuleSubtreeStream(this.adaptor, "rule anyString");
        RewriteRuleSubtreeStream stream_integer = new RewriteRuleSubtreeStream(this.adaptor, "rule integer");
        RewriteRuleSubtreeStream stream_enumeration = new RewriteRuleSubtreeStream(this.adaptor, "rule enumeration");
        RewriteRuleSubtreeStream stream_versionRange = new RewriteRuleSubtreeStream(this.adaptor, "rule versionRange");
        RewriteRuleSubtreeStream stream_integerRange = new RewriteRuleSubtreeStream(this.adaptor, "rule integerRange");
        RewriteRuleSubtreeStream stream_version = new RewriteRuleSubtreeStream(this.adaptor, "rule version");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:15:
            // ( ( anyString | enumeration | integer | integerRange | version | versionRange ) -> ^( STRINGSCHEMA (
            // anyString )? ( enumeration )? ( integer )? ( integerRange )? ( version )? ( versionRange )? ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:17:
            // ( anyString | enumeration | integer | integerRange | version | versionRange )
            {
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:17:
                // ( anyString | enumeration | integer | integerRange | version | versionRange )
                int alt4 = 6;
                switch (this.input.LA(1)) {
                    case 41:
                    case 42: {
                        alt4 = 1;
                    }
                        break;
                    case 43:
                    case 44: {
                        alt4 = 2;
                    }
                        break;
                    case 45:
                    case 46: {
                        alt4 = 3;
                    }
                        break;
                    case 39: {
                        int LA4_4 = this.input.LA(2);

                        if (LA4_4 == NUMBER) {
                            int LA4_7 = this.input.LA(3);

                            if (LA4_7 == 52) {
                                alt4 = 6;
                            } else if (LA4_7 == 37) {
                                alt4 = 4;
                            } else {
                                NoViableAltException nvae = new NoViableAltException(
                                    "82:17: ( anyString | enumeration | integer | integerRange | version | versionRange )", 4, 7, this.input);

                                throw nvae;
                            }
                        } else if (LA4_4 == 47) {
                            alt4 = 4;
                        } else {
                            NoViableAltException nvae = new NoViableAltException(
                                "82:17: ( anyString | enumeration | integer | integerRange | version | versionRange )", 4, 4, this.input);

                            throw nvae;
                        }
                    }
                        break;
                    case 48: {
                        int LA4_5 = this.input.LA(2);

                        if (LA4_5 == NUMBER) {
                            int LA4_9 = this.input.LA(3);

                            if (LA4_9 == 52) {
                                alt4 = 6;
                            } else if (LA4_9 == 37) {
                                alt4 = 4;
                            } else {
                                NoViableAltException nvae = new NoViableAltException(
                                    "82:17: ( anyString | enumeration | integer | integerRange | version | versionRange )", 4, 9, this.input);

                                throw nvae;
                            }
                        } else if (LA4_5 == 47) {
                            alt4 = 4;
                        } else {
                            NoViableAltException nvae = new NoViableAltException(
                                "82:17: ( anyString | enumeration | integer | integerRange | version | versionRange )", 4, 5, this.input);

                            throw nvae;
                        }
                    }
                        break;
                    case 50:
                    case 51: {
                        alt4 = 5;
                    }
                        break;
                    default:
                        NoViableAltException nvae = new NoViableAltException(
                            "82:17: ( anyString | enumeration | integer | integerRange | version | versionRange )", 4, 0, this.input);

                        throw nvae;
                }

                switch (alt4) {
                    case 1:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:19:
                        // anyString
                    {
                        pushFollow(FOLLOW_anyString_in_stringSchema352);
                        anyString21 = anyString();
                        this._fsp--;

                        stream_anyString.add(anyString21.getTree());

                    }
                        break;
                    case 2:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:31:
                        // enumeration
                    {
                        pushFollow(FOLLOW_enumeration_in_stringSchema356);
                        enumeration22 = enumeration();
                        this._fsp--;

                        stream_enumeration.add(enumeration22.getTree());

                    }
                        break;
                    case 3:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:45:
                        // integer
                    {
                        pushFollow(FOLLOW_integer_in_stringSchema360);
                        integer23 = integer();
                        this._fsp--;

                        stream_integer.add(integer23.getTree());

                    }
                        break;
                    case 4:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:55:
                        // integerRange
                    {
                        pushFollow(FOLLOW_integerRange_in_stringSchema364);
                        integerRange24 = integerRange();
                        this._fsp--;

                        stream_integerRange.add(integerRange24.getTree());

                    }
                        break;
                    case 5:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:70:
                        // version
                    {
                        pushFollow(FOLLOW_version_in_stringSchema368);
                        version25 = version();
                        this._fsp--;

                        stream_version.add(version25.getTree());

                    }
                        break;
                    case 6:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:82:80:
                        // versionRange
                    {
                        pushFollow(FOLLOW_versionRange_in_stringSchema372);
                        versionRange26 = versionRange();
                        this._fsp--;

                        stream_versionRange.add(versionRange26.getTree());

                    }
                        break;

                }

                // AST REWRITE
                // elements: integerRange, integer, version, enumeration, versionRange, anyString
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 83:3: -> ^( STRINGSCHEMA ( anyString )? ( enumeration )? ( integer )? ( integerRange )? ( version )?
                // ( versionRange )? )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:6:
                    // ^( STRINGSCHEMA ( anyString )? ( enumeration )? ( integer )? ( integerRange )? ( version )? (
                    // versionRange )? )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(STRINGSCHEMA, "STRINGSCHEMA"), root_1);

                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:22:
                        // ( anyString )?
                        if (stream_anyString.hasNext()) {
                            this.adaptor.addChild(root_1, stream_anyString.next());

                        }
                        stream_anyString.reset();
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:33:
                        // ( enumeration )?
                        if (stream_enumeration.hasNext()) {
                            this.adaptor.addChild(root_1, stream_enumeration.next());

                        }
                        stream_enumeration.reset();
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:46:
                        // ( integer )?
                        if (stream_integer.hasNext()) {
                            this.adaptor.addChild(root_1, stream_integer.next());

                        }
                        stream_integer.reset();
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:55:
                        // ( integerRange )?
                        if (stream_integerRange.hasNext()) {
                            this.adaptor.addChild(root_1, stream_integerRange.next());

                        }
                        stream_integerRange.reset();
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:69:
                        // ( version )?
                        if (stream_version.hasNext()) {
                            this.adaptor.addChild(root_1, stream_version.next());

                        }
                        stream_version.reset();
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:83:78:
                        // ( versionRange )?
                        if (stream_versionRange.hasNext()) {
                            this.adaptor.addChild(root_1, stream_versionRange.next());

                        }
                        stream_versionRange.reset();

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end stringSchema

    public static class anyString_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start anyString
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:90:1:
    // anyString : ( 'String' | 'string' ) -> ANYSTRING ;
    public final anyString_return anyString() throws RecognitionException {
        anyString_return retval = new anyString_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token string_literal27 = null;
        Token string_literal28 = null;

        RewriteRuleTokenStream stream_41 = new RewriteRuleTokenStream(this.adaptor, "token 41");
        RewriteRuleTokenStream stream_42 = new RewriteRuleTokenStream(this.adaptor, "token 42");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:90:11:
            // ( ( 'String' | 'string' ) -> ANYSTRING )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:90:13:
            // ( 'String' | 'string' )
            {
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:90:13:
                // ( 'String' | 'string' )
                int alt5 = 2;
                int LA5_0 = this.input.LA(1);

                if (LA5_0 == 41) {
                    alt5 = 1;
                } else if (LA5_0 == 42) {
                    alt5 = 2;
                } else {
                    NoViableAltException nvae = new NoViableAltException("90:13: ( 'String' | 'string' )", 5, 0, this.input);

                    throw nvae;
                }
                switch (alt5) {
                    case 1:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:90:15:
                        // 'String'
                    {
                        string_literal27 = (Token) this.input.LT(1);
                        match(this.input, 41, FOLLOW_41_in_anyString449);
                        stream_41.add(string_literal27);

                    }
                        break;
                    case 2:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:90:26:
                        // 'string'
                    {
                        string_literal28 = (Token) this.input.LT(1);
                        match(this.input, 42, FOLLOW_42_in_anyString453);
                        stream_42.add(string_literal28);

                    }
                        break;

                }

                // AST REWRITE
                // elements:
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 90:37: -> ANYSTRING
                {
                    this.adaptor.addChild(root_0, this.adaptor.create(ANYSTRING, "ANYSTRING"));

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end anyString

    public static class enumeration_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start enumeration
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:1:
    // enumeration : ( 'Enumeration' | 'enumeration' ) '{' IDENTIFIER ( ',' IDENTIFIER )* '}' -> ^( ENUM ( IDENTIFIER )+
    // ) ;
    public final enumeration_return enumeration() throws RecognitionException {
        enumeration_return retval = new enumeration_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token string_literal29 = null;
        Token string_literal30 = null;
        Token char_literal31 = null;
        Token IDENTIFIER32 = null;
        Token char_literal33 = null;
        Token IDENTIFIER34 = null;
        Token char_literal35 = null;

        RewriteRuleTokenStream stream_43 = new RewriteRuleTokenStream(this.adaptor, "token 43");
        RewriteRuleTokenStream stream_IDENTIFIER = new RewriteRuleTokenStream(this.adaptor, "token IDENTIFIER");
        RewriteRuleTokenStream stream_37 = new RewriteRuleTokenStream(this.adaptor, "token 37");
        RewriteRuleTokenStream stream_38 = new RewriteRuleTokenStream(this.adaptor, "token 38");
        RewriteRuleTokenStream stream_44 = new RewriteRuleTokenStream(this.adaptor, "token 44");
        RewriteRuleTokenStream stream_36 = new RewriteRuleTokenStream(this.adaptor, "token 36");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:13:
            // ( ( 'Enumeration' | 'enumeration' ) '{' IDENTIFIER ( ',' IDENTIFIER )* '}' -> ^( ENUM ( IDENTIFIER )+ ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:15:
            // ( 'Enumeration' | 'enumeration' ) '{' IDENTIFIER ( ',' IDENTIFIER )* '}'
            {
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:15:
                // ( 'Enumeration' | 'enumeration' )
                int alt6 = 2;
                int LA6_0 = this.input.LA(1);

                if (LA6_0 == 43) {
                    alt6 = 1;
                } else if (LA6_0 == 44) {
                    alt6 = 2;
                } else {
                    NoViableAltException nvae = new NoViableAltException("93:15: ( 'Enumeration' | 'enumeration' )", 6, 0, this.input);

                    throw nvae;
                }
                switch (alt6) {
                    case 1:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:17:
                        // 'Enumeration'
                    {
                        string_literal29 = (Token) this.input.LT(1);
                        match(this.input, 43, FOLLOW_43_in_enumeration472);
                        stream_43.add(string_literal29);

                    }
                        break;
                    case 2:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:33:
                        // 'enumeration'
                    {
                        string_literal30 = (Token) this.input.LT(1);
                        match(this.input, 44, FOLLOW_44_in_enumeration476);
                        stream_44.add(string_literal30);

                    }
                        break;

                }

                char_literal31 = (Token) this.input.LT(1);
                match(this.input, 36, FOLLOW_36_in_enumeration480);
                stream_36.add(char_literal31);

                IDENTIFIER32 = (Token) this.input.LT(1);
                match(this.input, IDENTIFIER, FOLLOW_IDENTIFIER_in_enumeration482);
                stream_IDENTIFIER.add(IDENTIFIER32);

                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:64:
                // ( ',' IDENTIFIER )*
                loop7: do {
                    int alt7 = 2;
                    int LA7_0 = this.input.LA(1);

                    if (LA7_0 == 37) {
                        alt7 = 1;
                    }

                    switch (alt7) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:65:
                            // ',' IDENTIFIER
                        {
                            char_literal33 = (Token) this.input.LT(1);
                            match(this.input, 37, FOLLOW_37_in_enumeration485);
                            stream_37.add(char_literal33);

                            IDENTIFIER34 = (Token) this.input.LT(1);
                            match(this.input, IDENTIFIER, FOLLOW_IDENTIFIER_in_enumeration487);
                            stream_IDENTIFIER.add(IDENTIFIER34);

                        }
                            break;

                        default:
                            break loop7;
                    }
                } while (true);

                char_literal35 = (Token) this.input.LT(1);
                match(this.input, 38, FOLLOW_38_in_enumeration491);
                stream_38.add(char_literal35);

                // AST REWRITE
                // elements: IDENTIFIER
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 93:86: -> ^( ENUM ( IDENTIFIER )+ )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:93:89:
                    // ^( ENUM ( IDENTIFIER )+ )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(ENUM, "ENUM"), root_1);

                        if (!stream_IDENTIFIER.hasNext()) {
                            throw new RewriteEarlyExitException();
                        }
                        while (stream_IDENTIFIER.hasNext()) {
                            this.adaptor.addChild(root_1, stream_IDENTIFIER.next());

                        }
                        stream_IDENTIFIER.reset();

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end enumeration

    public static class integer_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start integer
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:96:1:
    // integer : ( 'Int' | 'int' ) -> INTEGER ;
    public final integer_return integer() throws RecognitionException {
        integer_return retval = new integer_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token string_literal36 = null;
        Token string_literal37 = null;

        RewriteRuleTokenStream stream_46 = new RewriteRuleTokenStream(this.adaptor, "token 46");
        RewriteRuleTokenStream stream_45 = new RewriteRuleTokenStream(this.adaptor, "token 45");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:96:9:
            // ( ( 'Int' | 'int' ) -> INTEGER )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:96:11:
            // ( 'Int' | 'int' )
            {
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:96:11:
                // ( 'Int' | 'int' )
                int alt8 = 2;
                int LA8_0 = this.input.LA(1);

                if (LA8_0 == 45) {
                    alt8 = 1;
                } else if (LA8_0 == 46) {
                    alt8 = 2;
                } else {
                    NoViableAltException nvae = new NoViableAltException("96:11: ( 'Int' | 'int' )", 8, 0, this.input);

                    throw nvae;
                }
                switch (alt8) {
                    case 1:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:96:13:
                        // 'Int'
                    {
                        string_literal36 = (Token) this.input.LT(1);
                        match(this.input, 45, FOLLOW_45_in_integer514);
                        stream_45.add(string_literal36);

                    }
                        break;
                    case 2:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:96:21:
                        // 'int'
                    {
                        string_literal37 = (Token) this.input.LT(1);
                        match(this.input, 46, FOLLOW_46_in_integer518);
                        stream_46.add(string_literal37);

                    }
                        break;

                }

                // AST REWRITE
                // elements:
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 96:29: -> INTEGER
                {
                    this.adaptor.addChild(root_0, this.adaptor.create(INTEGER, "INTEGER"));

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end integer

    public static class integerRange_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start integerRange
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:99:1:
    // integerRange : integerRangeStart ',' integerRangeEnd -> ^( INTEGERRANGE integerRangeStart integerRangeEnd ) ;
    public final integerRange_return integerRange() throws RecognitionException {
        integerRange_return retval = new integerRange_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal39 = null;
        integerRangeStart_return integerRangeStart38 = null;

        integerRangeEnd_return integerRangeEnd40 = null;

        RewriteRuleTokenStream stream_37 = new RewriteRuleTokenStream(this.adaptor, "token 37");
        RewriteRuleSubtreeStream stream_integerRangeStart = new RewriteRuleSubtreeStream(this.adaptor, "rule integerRangeStart");
        RewriteRuleSubtreeStream stream_integerRangeEnd = new RewriteRuleSubtreeStream(this.adaptor, "rule integerRangeEnd");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:99:14:
            // ( integerRangeStart ',' integerRangeEnd -> ^( INTEGERRANGE integerRangeStart integerRangeEnd ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:99:16:
            // integerRangeStart ',' integerRangeEnd
            {
                pushFollow(FOLLOW_integerRangeStart_in_integerRange535);
                integerRangeStart38 = integerRangeStart();
                this._fsp--;

                stream_integerRangeStart.add(integerRangeStart38.getTree());
                char_literal39 = (Token) this.input.LT(1);
                match(this.input, 37, FOLLOW_37_in_integerRange537);
                stream_37.add(char_literal39);

                pushFollow(FOLLOW_integerRangeEnd_in_integerRange539);
                integerRangeEnd40 = integerRangeEnd();
                this._fsp--;

                stream_integerRangeEnd.add(integerRangeEnd40.getTree());

                // AST REWRITE
                // elements: integerRangeStart, integerRangeEnd
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 99:54: -> ^( INTEGERRANGE integerRangeStart integerRangeEnd )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:99:57:
                    // ^( INTEGERRANGE integerRangeStart integerRangeEnd )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTEGERRANGE, "INTEGERRANGE"), root_1);

                        this.adaptor.addChild(root_1, stream_integerRangeStart.next());
                        this.adaptor.addChild(root_1, stream_integerRangeEnd.next());

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end integerRange

    public static class integerRangeStart_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start integerRangeStart
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:1:
    // integerRangeStart : ( '[' '-' NUMBER -> ^( INTGE NUMBER NEGATIVE ) | '[' NUMBER -> ^( INTGE NUMBER POSITIVE ) |
    // '(' '-' NUMBER -> ^( INTG NUMBER NEGATIVE ) | '(' NUMBER -> ^( INTG NUMBER POSITIVE ) );
    public final integerRangeStart_return integerRangeStart() throws RecognitionException {
        integerRangeStart_return retval = new integerRangeStart_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal41 = null;
        Token char_literal42 = null;
        Token NUMBER43 = null;
        Token char_literal44 = null;
        Token NUMBER45 = null;
        Token char_literal46 = null;
        Token char_literal47 = null;
        Token NUMBER48 = null;
        Token char_literal49 = null;
        Token NUMBER50 = null;

        RewriteRuleTokenStream stream_48 = new RewriteRuleTokenStream(this.adaptor, "token 48");
        RewriteRuleTokenStream stream_47 = new RewriteRuleTokenStream(this.adaptor, "token 47");
        RewriteRuleTokenStream stream_NUMBER = new RewriteRuleTokenStream(this.adaptor, "token NUMBER");
        RewriteRuleTokenStream stream_39 = new RewriteRuleTokenStream(this.adaptor, "token 39");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:19:
            // ( '[' '-' NUMBER -> ^( INTGE NUMBER NEGATIVE ) | '[' NUMBER -> ^( INTGE NUMBER POSITIVE ) | '(' '-'
            // NUMBER -> ^( INTG NUMBER NEGATIVE ) | '(' NUMBER -> ^( INTG NUMBER POSITIVE ) )
            int alt9 = 4;
            int LA9_0 = this.input.LA(1);

            if (LA9_0 == 39) {
                int LA9_1 = this.input.LA(2);

                if (LA9_1 == NUMBER) {
                    alt9 = 2;
                } else if (LA9_1 == 47) {
                    alt9 = 1;
                } else {
                    NoViableAltException nvae = new NoViableAltException(
                        "102:1: integerRangeStart : ( '[' '-' NUMBER -> ^( INTGE NUMBER NEGATIVE ) | '[' NUMBER -> ^( INTGE NUMBER POSITIVE ) | '(' '-' NUMBER -> ^( INTG NUMBER NEGATIVE ) | '(' NUMBER -> ^( INTG NUMBER POSITIVE ) );",
                        9, 1, this.input);

                    throw nvae;
                }
            } else if (LA9_0 == 48) {
                int LA9_2 = this.input.LA(2);

                if (LA9_2 == 47) {
                    alt9 = 3;
                } else if (LA9_2 == NUMBER) {
                    alt9 = 4;
                } else {
                    NoViableAltException nvae = new NoViableAltException(
                        "102:1: integerRangeStart : ( '[' '-' NUMBER -> ^( INTGE NUMBER NEGATIVE ) | '[' NUMBER -> ^( INTGE NUMBER POSITIVE ) | '(' '-' NUMBER -> ^( INTG NUMBER NEGATIVE ) | '(' NUMBER -> ^( INTG NUMBER POSITIVE ) );",
                        9, 2, this.input);

                    throw nvae;
                }
            } else {
                NoViableAltException nvae = new NoViableAltException(
                    "102:1: integerRangeStart : ( '[' '-' NUMBER -> ^( INTGE NUMBER NEGATIVE ) | '[' NUMBER -> ^( INTGE NUMBER POSITIVE ) | '(' '-' NUMBER -> ^( INTG NUMBER NEGATIVE ) | '(' NUMBER -> ^( INTG NUMBER POSITIVE ) );",
                    9, 0, this.input);

                throw nvae;
            }
            switch (alt9) {
                case 1:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:21:
                    // '[' '-' NUMBER
                {
                    char_literal41 = (Token) this.input.LT(1);
                    match(this.input, 39, FOLLOW_39_in_integerRangeStart561);
                    stream_39.add(char_literal41);

                    char_literal42 = (Token) this.input.LT(1);
                    match(this.input, 47, FOLLOW_47_in_integerRangeStart563);
                    stream_47.add(char_literal42);

                    NUMBER43 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeStart565);
                    stream_NUMBER.add(NUMBER43);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 102:36: -> ^( INTGE NUMBER NEGATIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:39:
                        // ^( INTGE NUMBER NEGATIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTGE, "INTGE"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(NEGATIVE, "NEGATIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 2:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:68:
                    // '[' NUMBER
                {
                    char_literal44 = (Token) this.input.LT(1);
                    match(this.input, 39, FOLLOW_39_in_integerRangeStart581);
                    stream_39.add(char_literal44);

                    NUMBER45 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeStart583);
                    stream_NUMBER.add(NUMBER45);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 102:79: -> ^( INTGE NUMBER POSITIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:82:
                        // ^( INTGE NUMBER POSITIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTGE, "INTGE"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(POSITIVE, "POSITIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 3:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:111:
                    // '(' '-' NUMBER
                {
                    char_literal46 = (Token) this.input.LT(1);
                    match(this.input, 48, FOLLOW_48_in_integerRangeStart599);
                    stream_48.add(char_literal46);

                    char_literal47 = (Token) this.input.LT(1);
                    match(this.input, 47, FOLLOW_47_in_integerRangeStart601);
                    stream_47.add(char_literal47);

                    NUMBER48 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeStart603);
                    stream_NUMBER.add(NUMBER48);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 102:126: -> ^( INTG NUMBER NEGATIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:129:
                        // ^( INTG NUMBER NEGATIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTG, "INTG"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(NEGATIVE, "NEGATIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 4:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:157:
                    // '(' NUMBER
                {
                    char_literal49 = (Token) this.input.LT(1);
                    match(this.input, 48, FOLLOW_48_in_integerRangeStart619);
                    stream_48.add(char_literal49);

                    NUMBER50 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeStart621);
                    stream_NUMBER.add(NUMBER50);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 102:168: -> ^( INTG NUMBER POSITIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:102:171:
                        // ^( INTG NUMBER POSITIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTG, "INTG"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(POSITIVE, "POSITIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;

            }
            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end integerRangeStart

    public static class integerRangeEnd_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start integerRangeEnd
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:1:
    // integerRangeEnd : ( '-' NUMBER ']' -> ^( INTLE NUMBER NEGATIVE ) | NUMBER ']' -> ^( INTLE NUMBER POSITIVE ) | '-'
    // NUMBER ')' -> ^( INTL NUMBER NEGATIVE ) | NUMBER ')' -> ^( INTL NUMBER POSITIVE ) );
    public final integerRangeEnd_return integerRangeEnd() throws RecognitionException {
        integerRangeEnd_return retval = new integerRangeEnd_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal51 = null;
        Token NUMBER52 = null;
        Token char_literal53 = null;
        Token NUMBER54 = null;
        Token char_literal55 = null;
        Token char_literal56 = null;
        Token NUMBER57 = null;
        Token char_literal58 = null;
        Token NUMBER59 = null;
        Token char_literal60 = null;

        RewriteRuleTokenStream stream_40 = new RewriteRuleTokenStream(this.adaptor, "token 40");
        RewriteRuleTokenStream stream_47 = new RewriteRuleTokenStream(this.adaptor, "token 47");
        RewriteRuleTokenStream stream_NUMBER = new RewriteRuleTokenStream(this.adaptor, "token NUMBER");
        RewriteRuleTokenStream stream_49 = new RewriteRuleTokenStream(this.adaptor, "token 49");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:17:
            // ( '-' NUMBER ']' -> ^( INTLE NUMBER NEGATIVE ) | NUMBER ']' -> ^( INTLE NUMBER POSITIVE ) | '-' NUMBER
            // ')' -> ^( INTL NUMBER NEGATIVE ) | NUMBER ')' -> ^( INTL NUMBER POSITIVE ) )
            int alt10 = 4;
            int LA10_0 = this.input.LA(1);

            if (LA10_0 == 47) {
                int LA10_1 = this.input.LA(2);

                if (LA10_1 == NUMBER) {
                    int LA10_3 = this.input.LA(3);

                    if (LA10_3 == 49) {
                        alt10 = 3;
                    } else if (LA10_3 == 40) {
                        alt10 = 1;
                    } else {
                        NoViableAltException nvae = new NoViableAltException(
                            "105:1: integerRangeEnd : ( '-' NUMBER ']' -> ^( INTLE NUMBER NEGATIVE ) | NUMBER ']' -> ^( INTLE NUMBER POSITIVE ) | '-' NUMBER ')' -> ^( INTL NUMBER NEGATIVE ) | NUMBER ')' -> ^( INTL NUMBER POSITIVE ) );",
                            10, 3, this.input);

                        throw nvae;
                    }
                } else {
                    NoViableAltException nvae = new NoViableAltException(
                        "105:1: integerRangeEnd : ( '-' NUMBER ']' -> ^( INTLE NUMBER NEGATIVE ) | NUMBER ']' -> ^( INTLE NUMBER POSITIVE ) | '-' NUMBER ')' -> ^( INTL NUMBER NEGATIVE ) | NUMBER ')' -> ^( INTL NUMBER POSITIVE ) );",
                        10, 1, this.input);

                    throw nvae;
                }
            } else if (LA10_0 == NUMBER) {
                int LA10_2 = this.input.LA(2);

                if (LA10_2 == 49) {
                    alt10 = 4;
                } else if (LA10_2 == 40) {
                    alt10 = 2;
                } else {
                    NoViableAltException nvae = new NoViableAltException(
                        "105:1: integerRangeEnd : ( '-' NUMBER ']' -> ^( INTLE NUMBER NEGATIVE ) | NUMBER ']' -> ^( INTLE NUMBER POSITIVE ) | '-' NUMBER ')' -> ^( INTL NUMBER NEGATIVE ) | NUMBER ')' -> ^( INTL NUMBER POSITIVE ) );",
                        10, 2, this.input);

                    throw nvae;
                }
            } else {
                NoViableAltException nvae = new NoViableAltException(
                    "105:1: integerRangeEnd : ( '-' NUMBER ']' -> ^( INTLE NUMBER NEGATIVE ) | NUMBER ']' -> ^( INTLE NUMBER POSITIVE ) | '-' NUMBER ')' -> ^( INTL NUMBER NEGATIVE ) | NUMBER ')' -> ^( INTL NUMBER POSITIVE ) );",
                    10, 0, this.input);

                throw nvae;
            }
            switch (alt10) {
                case 1:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:19:
                    // '-' NUMBER ']'
                {
                    char_literal51 = (Token) this.input.LT(1);
                    match(this.input, 47, FOLLOW_47_in_integerRangeEnd643);
                    stream_47.add(char_literal51);

                    NUMBER52 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeEnd645);
                    stream_NUMBER.add(NUMBER52);

                    char_literal53 = (Token) this.input.LT(1);
                    match(this.input, 40, FOLLOW_40_in_integerRangeEnd647);
                    stream_40.add(char_literal53);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 105:34: -> ^( INTLE NUMBER NEGATIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:37:
                        // ^( INTLE NUMBER NEGATIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTLE, "INTLE"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(NEGATIVE, "NEGATIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 2:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:66:
                    // NUMBER ']'
                {
                    NUMBER54 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeEnd663);
                    stream_NUMBER.add(NUMBER54);

                    char_literal55 = (Token) this.input.LT(1);
                    match(this.input, 40, FOLLOW_40_in_integerRangeEnd665);
                    stream_40.add(char_literal55);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 105:77: -> ^( INTLE NUMBER POSITIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:80:
                        // ^( INTLE NUMBER POSITIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTLE, "INTLE"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(POSITIVE, "POSITIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 3:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:109:
                    // '-' NUMBER ')'
                {
                    char_literal56 = (Token) this.input.LT(1);
                    match(this.input, 47, FOLLOW_47_in_integerRangeEnd681);
                    stream_47.add(char_literal56);

                    NUMBER57 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeEnd683);
                    stream_NUMBER.add(NUMBER57);

                    char_literal58 = (Token) this.input.LT(1);
                    match(this.input, 49, FOLLOW_49_in_integerRangeEnd685);
                    stream_49.add(char_literal58);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 105:124: -> ^( INTL NUMBER NEGATIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:127:
                        // ^( INTL NUMBER NEGATIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTL, "INTL"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(NEGATIVE, "NEGATIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 4:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:155:
                    // NUMBER ')'
                {
                    NUMBER59 = (Token) this.input.LT(1);
                    match(this.input, NUMBER, FOLLOW_NUMBER_in_integerRangeEnd701);
                    stream_NUMBER.add(NUMBER59);

                    char_literal60 = (Token) this.input.LT(1);
                    match(this.input, 49, FOLLOW_49_in_integerRangeEnd703);
                    stream_49.add(char_literal60);

                    // AST REWRITE
                    // elements: NUMBER
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 105:166: -> ^( INTL NUMBER POSITIVE )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:105:169:
                        // ^( INTL NUMBER POSITIVE )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(INTL, "INTL"), root_1);

                            this.adaptor.addChild(root_1, stream_NUMBER.next());
                            this.adaptor.addChild(root_1, this.adaptor.create(POSITIVE, "POSITIVE"));

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;

            }
            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end integerRangeEnd

    public static class version_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start version
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:108:1:
    // version : ( 'versionNumber' | 'VersionNumber' ) -> VERSION ;
    public final version_return version() throws RecognitionException {
        version_return retval = new version_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token string_literal61 = null;
        Token string_literal62 = null;

        RewriteRuleTokenStream stream_50 = new RewriteRuleTokenStream(this.adaptor, "token 50");
        RewriteRuleTokenStream stream_51 = new RewriteRuleTokenStream(this.adaptor, "token 51");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:108:9:
            // ( ( 'versionNumber' | 'VersionNumber' ) -> VERSION )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:108:11:
            // ( 'versionNumber' | 'VersionNumber' )
            {
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:108:11:
                // ( 'versionNumber' | 'VersionNumber' )
                int alt11 = 2;
                int LA11_0 = this.input.LA(1);

                if (LA11_0 == 50) {
                    alt11 = 1;
                } else if (LA11_0 == 51) {
                    alt11 = 2;
                } else {
                    NoViableAltException nvae = new NoViableAltException("108:11: ( 'versionNumber' | 'VersionNumber' )", 11, 0, this.input);

                    throw nvae;
                }
                switch (alt11) {
                    case 1:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:108:13:
                        // 'versionNumber'
                    {
                        string_literal61 = (Token) this.input.LT(1);
                        match(this.input, 50, FOLLOW_50_in_version728);
                        stream_50.add(string_literal61);

                    }
                        break;
                    case 2:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:108:31:
                        // 'VersionNumber'
                    {
                        string_literal62 = (Token) this.input.LT(1);
                        match(this.input, 51, FOLLOW_51_in_version732);
                        stream_51.add(string_literal62);

                    }
                        break;

                }

                // AST REWRITE
                // elements:
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 108:49: -> VERSION
                {
                    this.adaptor.addChild(root_0, this.adaptor.create(VERSION, "VERSION"));

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end version

    public static class versionValue_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start versionValue
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:111:1:
    // versionValue : NUMBER '.' NUMBER ( '.' NUMBER )* -> ^( VERSIONVALUE ( NUMBER )+ ) ;
    public final versionValue_return versionValue() throws RecognitionException {
        versionValue_return retval = new versionValue_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token NUMBER63 = null;
        Token char_literal64 = null;
        Token NUMBER65 = null;
        Token char_literal66 = null;
        Token NUMBER67 = null;

        RewriteRuleTokenStream stream_52 = new RewriteRuleTokenStream(this.adaptor, "token 52");
        RewriteRuleTokenStream stream_NUMBER = new RewriteRuleTokenStream(this.adaptor, "token NUMBER");

        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:111:14:
            // ( NUMBER '.' NUMBER ( '.' NUMBER )* -> ^( VERSIONVALUE ( NUMBER )+ ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:111:16:
            // NUMBER '.' NUMBER ( '.' NUMBER )*
            {
                NUMBER63 = (Token) this.input.LT(1);
                match(this.input, NUMBER, FOLLOW_NUMBER_in_versionValue748);
                stream_NUMBER.add(NUMBER63);

                char_literal64 = (Token) this.input.LT(1);
                match(this.input, 52, FOLLOW_52_in_versionValue750);
                stream_52.add(char_literal64);

                NUMBER65 = (Token) this.input.LT(1);
                match(this.input, NUMBER, FOLLOW_NUMBER_in_versionValue752);
                stream_NUMBER.add(NUMBER65);

                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:111:34:
                // ( '.' NUMBER )*
                loop12: do {
                    int alt12 = 2;
                    int LA12_0 = this.input.LA(1);

                    if (LA12_0 == 52) {
                        alt12 = 1;
                    }

                    switch (alt12) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:111:35:
                            // '.' NUMBER
                        {
                            char_literal66 = (Token) this.input.LT(1);
                            match(this.input, 52, FOLLOW_52_in_versionValue755);
                            stream_52.add(char_literal66);

                            NUMBER67 = (Token) this.input.LT(1);
                            match(this.input, NUMBER, FOLLOW_NUMBER_in_versionValue757);
                            stream_NUMBER.add(NUMBER67);

                        }
                            break;

                        default:
                            break loop12;
                    }
                } while (true);

                // AST REWRITE
                // elements: NUMBER
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 111:48: -> ^( VERSIONVALUE ( NUMBER )+ )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:111:51:
                    // ^( VERSIONVALUE ( NUMBER )+ )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(VERSIONVALUE, "VERSIONVALUE"), root_1);

                        if (!stream_NUMBER.hasNext()) {
                            throw new RewriteEarlyExitException();
                        }
                        while (stream_NUMBER.hasNext()) {
                            this.adaptor.addChild(root_1, stream_NUMBER.next());

                        }
                        stream_NUMBER.reset();

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end versionValue

    public static class versionRange_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start versionRange
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:115:1:
    // versionRange : versionRangeStart ',' versionRangeEnd -> ^( VERSIONRANGE versionRangeStart versionRangeEnd ) ;
    public final versionRange_return versionRange() throws RecognitionException {
        versionRange_return retval = new versionRange_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal69 = null;
        versionRangeStart_return versionRangeStart68 = null;

        versionRangeEnd_return versionRangeEnd70 = null;

        RewriteRuleTokenStream stream_37 = new RewriteRuleTokenStream(this.adaptor, "token 37");
        RewriteRuleSubtreeStream stream_versionRangeStart = new RewriteRuleSubtreeStream(this.adaptor, "rule versionRangeStart");
        RewriteRuleSubtreeStream stream_versionRangeEnd = new RewriteRuleSubtreeStream(this.adaptor, "rule versionRangeEnd");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:115:14:
            // ( versionRangeStart ',' versionRangeEnd -> ^( VERSIONRANGE versionRangeStart versionRangeEnd ) )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:115:16:
            // versionRangeStart ',' versionRangeEnd
            {
                pushFollow(FOLLOW_versionRangeStart_in_versionRange782);
                versionRangeStart68 = versionRangeStart();
                this._fsp--;

                stream_versionRangeStart.add(versionRangeStart68.getTree());
                char_literal69 = (Token) this.input.LT(1);
                match(this.input, 37, FOLLOW_37_in_versionRange784);
                stream_37.add(char_literal69);

                pushFollow(FOLLOW_versionRangeEnd_in_versionRange786);
                versionRangeEnd70 = versionRangeEnd();
                this._fsp--;

                stream_versionRangeEnd.add(versionRangeEnd70.getTree());

                // AST REWRITE
                // elements: versionRangeEnd, versionRangeStart
                // token labels:
                // rule labels: retval
                // token list labels:
                // rule list labels:
                retval.tree = root_0;
                RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                    : null);

                root_0 = (Object) this.adaptor.nil();
                // 115:54: -> ^( VERSIONRANGE versionRangeStart versionRangeEnd )
                {
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:115:57:
                    // ^( VERSIONRANGE versionRangeStart versionRangeEnd )
                    {
                        Object root_1 = (Object) this.adaptor.nil();
                        root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(VERSIONRANGE, "VERSIONRANGE"), root_1);

                        this.adaptor.addChild(root_1, stream_versionRangeStart.next());
                        this.adaptor.addChild(root_1, stream_versionRangeEnd.next());

                        this.adaptor.addChild(root_0, root_1);
                    }

                }

            }

            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end versionRange

    public static class versionRangeStart_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start versionRangeStart
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:118:1:
    // versionRangeStart : ( '[' versionValue -> ^( VERGE versionValue ) | '(' versionValue -> ^( VERG versionValue ) );
    public final versionRangeStart_return versionRangeStart() throws RecognitionException {
        versionRangeStart_return retval = new versionRangeStart_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal71 = null;
        Token char_literal73 = null;
        versionValue_return versionValue72 = null;

        versionValue_return versionValue74 = null;

        RewriteRuleTokenStream stream_48 = new RewriteRuleTokenStream(this.adaptor, "token 48");
        RewriteRuleTokenStream stream_39 = new RewriteRuleTokenStream(this.adaptor, "token 39");
        RewriteRuleSubtreeStream stream_versionValue = new RewriteRuleSubtreeStream(this.adaptor, "rule versionValue");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:118:19:
            // ( '[' versionValue -> ^( VERGE versionValue ) | '(' versionValue -> ^( VERG versionValue ) )
            int alt13 = 2;
            int LA13_0 = this.input.LA(1);

            if (LA13_0 == 39) {
                alt13 = 1;
            } else if (LA13_0 == 48) {
                alt13 = 2;
            } else {
                NoViableAltException nvae = new NoViableAltException(
                    "118:1: versionRangeStart : ( '[' versionValue -> ^( VERGE versionValue ) | '(' versionValue -> ^( VERG versionValue ) );", 13,
                    0, this.input);

                throw nvae;
            }
            switch (alt13) {
                case 1:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:118:21:
                    // '[' versionValue
                {
                    char_literal71 = (Token) this.input.LT(1);
                    match(this.input, 39, FOLLOW_39_in_versionRangeStart808);
                    stream_39.add(char_literal71);

                    pushFollow(FOLLOW_versionValue_in_versionRangeStart810);
                    versionValue72 = versionValue();
                    this._fsp--;

                    stream_versionValue.add(versionValue72.getTree());

                    // AST REWRITE
                    // elements: versionValue
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 118:38: -> ^( VERGE versionValue )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:118:41:
                        // ^( VERGE versionValue )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(VERGE, "VERGE"), root_1);

                            this.adaptor.addChild(root_1, stream_versionValue.next());

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 2:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:118:67:
                    // '(' versionValue
                {
                    char_literal73 = (Token) this.input.LT(1);
                    match(this.input, 48, FOLLOW_48_in_versionRangeStart824);
                    stream_48.add(char_literal73);

                    pushFollow(FOLLOW_versionValue_in_versionRangeStart826);
                    versionValue74 = versionValue();
                    this._fsp--;

                    stream_versionValue.add(versionValue74.getTree());

                    // AST REWRITE
                    // elements: versionValue
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 118:84: -> ^( VERG versionValue )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:118:87:
                        // ^( VERG versionValue )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(VERG, "VERG"), root_1);

                            this.adaptor.addChild(root_1, stream_versionValue.next());

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;

            }
            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end versionRangeStart

    public static class versionRangeEnd_return extends ParserRuleReturnScope {

        Object tree;

        public Object getTree() {
            return this.tree;
        }
    };

    // $ANTLR start versionRangeEnd
    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:121:1:
    // versionRangeEnd : ( versionValue ']' -> ^( VERLE versionValue ) | versionValue ')' -> ^( VERL versionValue ) );
    public final versionRangeEnd_return versionRangeEnd() throws RecognitionException {
        versionRangeEnd_return retval = new versionRangeEnd_return();
        retval.start = this.input.LT(1);

        Object root_0 = null;

        Token char_literal76 = null;
        Token char_literal78 = null;
        versionValue_return versionValue75 = null;

        versionValue_return versionValue77 = null;

        RewriteRuleTokenStream stream_40 = new RewriteRuleTokenStream(this.adaptor, "token 40");
        RewriteRuleTokenStream stream_49 = new RewriteRuleTokenStream(this.adaptor, "token 49");
        RewriteRuleSubtreeStream stream_versionValue = new RewriteRuleSubtreeStream(this.adaptor, "rule versionValue");
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:121:17:
            // ( versionValue ']' -> ^( VERLE versionValue ) | versionValue ')' -> ^( VERL versionValue ) )
            int alt14 = 2;
            alt14 = this.dfa14.predict(this.input);
            switch (alt14) {
                case 1:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:121:19:
                    // versionValue ']'
                {
                    pushFollow(FOLLOW_versionValue_in_versionRangeEnd847);
                    versionValue75 = versionValue();
                    this._fsp--;

                    stream_versionValue.add(versionValue75.getTree());
                    char_literal76 = (Token) this.input.LT(1);
                    match(this.input, 40, FOLLOW_40_in_versionRangeEnd849);
                    stream_40.add(char_literal76);

                    // AST REWRITE
                    // elements: versionValue
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 121:36: -> ^( VERLE versionValue )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:121:39:
                        // ^( VERLE versionValue )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(VERLE, "VERLE"), root_1);

                            this.adaptor.addChild(root_1, stream_versionValue.next());

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;
                case 2:
                    // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:121:65:
                    // versionValue ')'
                {
                    pushFollow(FOLLOW_versionValue_in_versionRangeEnd863);
                    versionValue77 = versionValue();
                    this._fsp--;

                    stream_versionValue.add(versionValue77.getTree());
                    char_literal78 = (Token) this.input.LT(1);
                    match(this.input, 49, FOLLOW_49_in_versionRangeEnd865);
                    stream_49.add(char_literal78);

                    // AST REWRITE
                    // elements: versionValue
                    // token labels:
                    // rule labels: retval
                    // token list labels:
                    // rule list labels:
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(this.adaptor, "token retval", retval != null ? retval.tree
                        : null);

                    root_0 = (Object) this.adaptor.nil();
                    // 121:82: -> ^( VERL versionValue )
                    {
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:121:85:
                        // ^( VERL versionValue )
                        {
                            Object root_1 = (Object) this.adaptor.nil();
                            root_1 = (Object) this.adaptor.becomeRoot(this.adaptor.create(VERL, "VERL"), root_1);

                            this.adaptor.addChild(root_1, stream_versionValue.next());

                            this.adaptor.addChild(root_0, root_1);
                        }

                    }

                }
                    break;

            }
            retval.stop = this.input.LT(-1);

            retval.tree = (Object) this.adaptor.rulePostProcessing(root_0);
            this.adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        catch (RecognitionException e) {
            reportError(e);
            throw e;
        } finally {
        }
        return retval;
    }

    // $ANTLR end versionRangeEnd

    protected DFA14 dfa14 = new DFA14(this);

    static final String DFA14_eotS = "\10\uffff";

    static final String DFA14_eofS = "\10\uffff";

    static final String DFA14_minS = "\1\37\1\64\1\37\1\50\1\37\2\uffff\1\50";

    static final String DFA14_maxS = "\1\37\1\64\1\37\1\64\1\37\2\uffff\1\64";

    static final String DFA14_acceptS = "\5\uffff\1\1\1\2\1\uffff";

    static final String DFA14_specialS = "\10\uffff}>";

    static final String[] DFA14_transitionS = { "\1\1", "\1\2", "\1\3", "\1\5\10\uffff\1\6\2\uffff\1\4", "\1\7", "", "",
        "\1\5\10\uffff\1\6\2\uffff\1\4" };

    static final short[] DFA14_eot = DFA.unpackEncodedString(DFA14_eotS);

    static final short[] DFA14_eof = DFA.unpackEncodedString(DFA14_eofS);

    static final char[] DFA14_min = DFA.unpackEncodedStringToUnsignedChars(DFA14_minS);

    static final char[] DFA14_max = DFA.unpackEncodedStringToUnsignedChars(DFA14_maxS);

    static final short[] DFA14_accept = DFA.unpackEncodedString(DFA14_acceptS);

    static final short[] DFA14_special = DFA.unpackEncodedString(DFA14_specialS);

    static final short[][] DFA14_transition;

    static {
        int numStates = DFA14_transitionS.length;
        DFA14_transition = new short[numStates][];
        for (int i = 0; i < numStates; i++) {
            DFA14_transition[i] = DFA.unpackEncodedString(DFA14_transitionS[i]);
        }
    }

    class DFA14 extends DFA {

        public DFA14(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 14;
            this.eot = DFA14_eot;
            this.eof = DFA14_eof;
            this.min = DFA14_min;
            this.max = DFA14_max;
            this.accept = DFA14_accept;
            this.special = DFA14_special;
            this.transition = DFA14_transition;
        }

        public String getDescription() {
            return "121:1: versionRangeEnd : ( versionValue ']' -> ^( VERLE versionValue ) | versionValue ')' -> ^( VERL versionValue ) );";
        }
    }

    public static final BitSet FOLLOW_IDENTIFIER_in_configPointSchema176 = new BitSet(new long[] { 0x0000000800000000L });

    public static final BitSet FOLLOW_35_in_configPointSchema178 = new BitSet(new long[] { 0x0000009000000000L });

    public static final BitSet FOLLOW_configurationSchema_in_configPointSchema180 = new BitSet(new long[] { 0x0000000000000000L });

    public static final BitSet FOLLOW_EOF_in_configPointSchema182 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_mapSchema_in_configurationSchema207 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_listSchema_in_configurationSchema211 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_36_in_mapSchema223 = new BitSet(new long[] { 0x0000000010000000L });

    public static final BitSet FOLLOW_mapletSchema_in_mapSchema225 = new BitSet(new long[] { 0x0000006000000000L });

    public static final BitSet FOLLOW_37_in_mapSchema229 = new BitSet(new long[] { 0x0000000010000000L });

    public static final BitSet FOLLOW_mapletSchema_in_mapSchema231 = new BitSet(new long[] { 0x0000006000000000L });

    public static final BitSet FOLLOW_38_in_mapSchema236 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_key_in_mapletSchema257 = new BitSet(new long[] { 0x0000000800000000L });

    public static final BitSet FOLLOW_35_in_mapletSchema259 = new BitSet(new long[] { 0x000D7E9000000000L });

    public static final BitSet FOLLOW_valueSchema_in_mapletSchema261 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_stringSchema_in_valueSchema284 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_configurationSchema_in_valueSchema288 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_39_in_listSchema300 = new BitSet(new long[] { 0x000D7E9000000000L });

    public static final BitSet FOLLOW_valueSchema_in_listSchema302 = new BitSet(new long[] { 0x0000010000000000L });

    public static final BitSet FOLLOW_40_in_listSchema304 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_IDENTIFIER_in_key326 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_anyString_in_stringSchema352 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_enumeration_in_stringSchema356 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_integer_in_stringSchema360 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_integerRange_in_stringSchema364 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_version_in_stringSchema368 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_versionRange_in_stringSchema372 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_41_in_anyString449 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_42_in_anyString453 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_43_in_enumeration472 = new BitSet(new long[] { 0x0000001000000000L });

    public static final BitSet FOLLOW_44_in_enumeration476 = new BitSet(new long[] { 0x0000001000000000L });

    public static final BitSet FOLLOW_36_in_enumeration480 = new BitSet(new long[] { 0x0000000010000000L });

    public static final BitSet FOLLOW_IDENTIFIER_in_enumeration482 = new BitSet(new long[] { 0x0000006000000000L });

    public static final BitSet FOLLOW_37_in_enumeration485 = new BitSet(new long[] { 0x0000000010000000L });

    public static final BitSet FOLLOW_IDENTIFIER_in_enumeration487 = new BitSet(new long[] { 0x0000006000000000L });

    public static final BitSet FOLLOW_38_in_enumeration491 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_45_in_integer514 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_46_in_integer518 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_integerRangeStart_in_integerRange535 = new BitSet(new long[] { 0x0000002000000000L });

    public static final BitSet FOLLOW_37_in_integerRange537 = new BitSet(new long[] { 0x0000800080000000L });

    public static final BitSet FOLLOW_integerRangeEnd_in_integerRange539 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_39_in_integerRangeStart561 = new BitSet(new long[] { 0x0000800000000000L });

    public static final BitSet FOLLOW_47_in_integerRangeStart563 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeStart565 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_39_in_integerRangeStart581 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeStart583 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_48_in_integerRangeStart599 = new BitSet(new long[] { 0x0000800000000000L });

    public static final BitSet FOLLOW_47_in_integerRangeStart601 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeStart603 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_48_in_integerRangeStart619 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeStart621 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_47_in_integerRangeEnd643 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeEnd645 = new BitSet(new long[] { 0x0000010000000000L });

    public static final BitSet FOLLOW_40_in_integerRangeEnd647 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeEnd663 = new BitSet(new long[] { 0x0000010000000000L });

    public static final BitSet FOLLOW_40_in_integerRangeEnd665 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_47_in_integerRangeEnd681 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeEnd683 = new BitSet(new long[] { 0x0002000000000000L });

    public static final BitSet FOLLOW_49_in_integerRangeEnd685 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_NUMBER_in_integerRangeEnd701 = new BitSet(new long[] { 0x0002000000000000L });

    public static final BitSet FOLLOW_49_in_integerRangeEnd703 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_50_in_version728 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_51_in_version732 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_NUMBER_in_versionValue748 = new BitSet(new long[] { 0x0010000000000000L });

    public static final BitSet FOLLOW_52_in_versionValue750 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_versionValue752 = new BitSet(new long[] { 0x0010000000000002L });

    public static final BitSet FOLLOW_52_in_versionValue755 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_NUMBER_in_versionValue757 = new BitSet(new long[] { 0x0010000000000002L });

    public static final BitSet FOLLOW_versionRangeStart_in_versionRange782 = new BitSet(new long[] { 0x0000002000000000L });

    public static final BitSet FOLLOW_37_in_versionRange784 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_versionRangeEnd_in_versionRange786 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_39_in_versionRangeStart808 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_versionValue_in_versionRangeStart810 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_48_in_versionRangeStart824 = new BitSet(new long[] { 0x0000000080000000L });

    public static final BitSet FOLLOW_versionValue_in_versionRangeStart826 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_versionValue_in_versionRangeEnd847 = new BitSet(new long[] { 0x0000010000000000L });

    public static final BitSet FOLLOW_40_in_versionRangeEnd849 = new BitSet(new long[] { 0x0000000000000002L });

    public static final BitSet FOLLOW_versionValue_in_versionRangeEnd863 = new BitSet(new long[] { 0x0002000000000000L });

    public static final BitSet FOLLOW_49_in_versionRangeEnd865 = new BitSet(new long[] { 0x0000000000000002L });

}
