/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.ffdc.core.internal;

import com.springsource.server.serviceability.ffdc.FatalServerException;

/**
 * Thrown to denote an unrecoverable error within a
 * {@link com.springsource.server.serviceability.ffdc.DumpGenerator DumpGenerator} or
 * {@link com.springsource.server.serviceability.ffdc.DumpWriter DumpWriter}, likely the result of a
 * configuration error.
 * 
 * @author Sam Brannen
 * @since 1.0
 */
class FatalDumpException extends FatalServerException {

    private static final long serialVersionUID = 7600871086450316679L;

    FatalDumpException(String message, Throwable cause) {
        super(message, cause);
    }

    FatalDumpException(String message) {
        super(message);
    }
}
