/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.io.core.fs;

/**
 * Listener that is notified of file system modifications.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br/>
 * 
 * Implementations <code>must</code> be threadsafe.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
public interface FileSystemListener {

    /**
     * Signals an event at the supplied file path.
     * 
     * @param path the path for which the event occurred.
     * @param event the event that occurred.
     */
    void onChange(String path, FileSystemEvent event);
}
