/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.kernel.core;

import com.springsource.server.serviceability.ffdc.ServerException;

/**
 * Signals an error detected by the kernel.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br/>
 * 
 * Threadsafe.
 * 
 * @author Glyn Normington
 * @since 1.0
 */
public class KernelException extends ServerException {

    private static final long serialVersionUID = 13289732386414L;

    /**
     * Creates a new {@link KernelException}.
     * 
     * @param message the error message.
     */
    public KernelException(String message) {
        super(message);
    }

    /**
     * Creates a new {@link KernelException}.
     * 
     * @param message the error message.
     * @param cause the root cause.
     */
    public KernelException(String message, Throwable cause) {
        super(message, cause);
    }

}
