/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.osgi.manifest;

import java.util.jar.Attributes;

/**
 * @author Glyn Normington
 * @since 1.0
 */
class BundleManifestVersionDelegate extends BaseStringHeaderDelegate {

    private static final String BUNDLE_MANIFEST_VERSION_HEADER_NAME = "Bundle-ManifestVersion";

    private static final int DEFAULT_BUNDLE_MANIFEST_VERSION = 1;

    private int bundleManifestVersion = DEFAULT_BUNDLE_MANIFEST_VERSION;

    public BundleManifestVersionDelegate(Attributes mainAttributes) {
        super(mainAttributes, BUNDLE_MANIFEST_VERSION_HEADER_NAME);
        if (getField() != null) {
            this.bundleManifestVersion = Integer.parseInt(getField());
        }
    }

    public int getBundleManifestVersion() {
        return this.bundleManifestVersion;
    }

    public void setBundleManifestVersion(int bundleManifestVersion) {
        setField(new Integer(bundleManifestVersion).toString());
        this.bundleManifestVersion = bundleManifestVersion;
    }
}
