/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.osgi.manifest.parse;

import org.antlr.runtime.CharStream;
import org.antlr.runtime.EarlyExitException;
import org.antlr.runtime.Lexer;
import org.antlr.runtime.MismatchedSetException;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.RecognitionException;

public class OsgiHeaderLexer extends Lexer {

    public static final int T21 = 21;

    public static final int T14 = 14;

    public static final int T22 = 22;

    public static final int T11 = 11;

    public static final int WS = 9;

    public static final int ALPHA = 6;

    public static final int T12 = 12;

    public static final int T23 = 23;

    public static final int DOTSTAR = 8;

    public static final int T13 = 13;

    public static final int T20 = 20;

    public static final int T10 = 10;

    public static final int T18 = 18;

    public static final int T15 = 15;

    public static final int QUOTED_STRING = 4;

    public static final int EOF = -1;

    public static final int T17 = 17;

    public static final int Tokens = 24;

    public static final int DIGIT = 7;

    public static final int T16 = 16;

    public static final int STAR = 5;

    public static final int T19 = 19;

    public OsgiHeaderLexer() {
        ;
    }

    public OsgiHeaderLexer(CharStream input) {
        super(input);
    }

    public String getGrammarFileName() {
        return "/Users/awilkinson/Documents/dev/tm/engine/com.springsource.server.osgi/com.springsource.server.osgi.manifest/src/main/java/com/springsource/server/osgi/manifest/parse/OsgiHeader.g";
    }

    public final void mT10() throws RecognitionException {
        try {
            int _type = T10;
            {
                match(',');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT11() throws RecognitionException {
        try {
            int _type = T11;
            {
                match(';');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT12() throws RecognitionException {
        try {
            int _type = T12;
            {
                match(":=");

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT13() throws RecognitionException {
        try {
            int _type = T13;
            {
                match('=');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT14() throws RecognitionException {
        try {
            int _type = T14;
            {
                match('/');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT15() throws RecognitionException {
        try {
            int _type = T15;
            {
                match('-');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT16() throws RecognitionException {
        try {
            int _type = T16;
            {
                match('_');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT17() throws RecognitionException {
        try {
            int _type = T17;
            {
                match('.');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT18() throws RecognitionException {
        try {
            int _type = T18;
            {
                match('+');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT19() throws RecognitionException {
        try {
            int _type = T19;
            {
                match('!');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT20() throws RecognitionException {
        try {
            int _type = T20;
            {
                match('\'');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT21() throws RecognitionException {
        try {
            int _type = T21;
            {
                match('(');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT22() throws RecognitionException {
        try {
            int _type = T22;
            {
                match(')');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mT23() throws RecognitionException {
        try {
            int _type = T23;
            {
                match('$');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mQUOTED_STRING() throws RecognitionException {
        try {
            int _type = QUOTED_STRING;
            {
                match('\"');
                loop1: do {
                    int alt1 = 3;
                    int LA1_0 = input.LA(1);

                    if (((LA1_0 >= '\u0000' && LA1_0 <= '\t') || (LA1_0 >= '\u000B' && LA1_0 <= '\f') || (LA1_0 >= '\u000E' && LA1_0 <= '!')
                        || (LA1_0 >= '#' && LA1_0 <= '[') || (LA1_0 >= ']' && LA1_0 <= '\uFFFE'))) {
                        alt1 = 1;
                    } else if ((LA1_0 == '\\')) {
                        alt1 = 2;
                    }

                    switch (alt1) {
                        case 1: {
                            if ((input.LA(1) >= '\u0000' && input.LA(1) <= '\t') || (input.LA(1) >= '\u000B' && input.LA(1) <= '\f')
                                || (input.LA(1) >= '\u000E' && input.LA(1) <= '!') || (input.LA(1) >= '#' && input.LA(1) <= '[')
                                || (input.LA(1) >= ']' && input.LA(1) <= '\uFFFE')) {
                                input.consume();

                            } else {
                                MismatchedSetException mse = new MismatchedSetException(null, input);
                                recover(mse);
                                throw mse;
                            }

                        }
                            break;
                        case 2: {
                            match('\\');
                            if (input.LA(1) == '\"' || input.LA(1) == '\\') {
                                input.consume();

                            } else {
                                MismatchedSetException mse = new MismatchedSetException(null, input);
                                recover(mse);
                                throw mse;
                            }

                        }
                            break;

                        default:
                            break loop1;
                    }
                } while (true);

                match('\"');
                setText(getText().substring(1, getText().length() - 1));

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mDIGIT() throws RecognitionException {
        try {
            int _type = DIGIT;
            {
                matchRange('0', '9');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mALPHA() throws RecognitionException {
        try {
            int _type = ALPHA;
            {
                if ((input.LA(1) >= 'A' && input.LA(1) <= 'Z') || (input.LA(1) >= 'a' && input.LA(1) <= 'z')) {
                    input.consume();

                } else {
                    MismatchedSetException mse = new MismatchedSetException(null, input);
                    recover(mse);
                    throw mse;
                }

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mDOTSTAR() throws RecognitionException {
        try {
            int _type = DOTSTAR;
            {
                match(".*");

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mSTAR() throws RecognitionException {
        try {
            int _type = STAR;
            {
                match('*');

            }

            this.type = _type;
        } finally {
        }
    }

    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            {
                int cnt2 = 0;
                loop2: do {
                    int alt2 = 2;
                    int LA2_0 = input.LA(1);

                    if ((LA2_0 == ' ')) {
                        alt2 = 1;
                    }

                    switch (alt2) {
                        case 1: {
                            match(' ');

                        }
                            break;

                        default:
                            if (cnt2 >= 1)
                                break loop2;
                            EarlyExitException eee = new EarlyExitException(2, input);
                            throw eee;
                    }
                    cnt2++;
                } while (true);

                skip();

            }

            this.type = _type;
        } finally {
        }
    }

    public void mTokens() throws RecognitionException {
        int alt3 = 20;
        switch (input.LA(1)) {
            case ',': {
                alt3 = 1;
            }
                break;
            case ';': {
                alt3 = 2;
            }
                break;
            case ':': {
                alt3 = 3;
            }
                break;
            case '=': {
                alt3 = 4;
            }
                break;
            case '/': {
                alt3 = 5;
            }
                break;
            case '-': {
                alt3 = 6;
            }
                break;
            case '_': {
                alt3 = 7;
            }
                break;
            case '.': {
                int LA3_8 = input.LA(2);

                if ((LA3_8 == '*')) {
                    alt3 = 18;
                } else {
                    alt3 = 8;
                }
            }
                break;
            case '+': {
                alt3 = 9;
            }
                break;
            case '!': {
                alt3 = 10;
            }
                break;
            case '\'': {
                alt3 = 11;
            }
                break;
            case '(': {
                alt3 = 12;
            }
                break;
            case ')': {
                alt3 = 13;
            }
                break;
            case '$': {
                alt3 = 14;
            }
                break;
            case '\"': {
                alt3 = 15;
            }
                break;
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9': {
                alt3 = 16;
            }
                break;
            case 'A':
            case 'B':
            case 'C':
            case 'D':
            case 'E':
            case 'F':
            case 'G':
            case 'H':
            case 'I':
            case 'J':
            case 'K':
            case 'L':
            case 'M':
            case 'N':
            case 'O':
            case 'P':
            case 'Q':
            case 'R':
            case 'S':
            case 'T':
            case 'U':
            case 'V':
            case 'W':
            case 'X':
            case 'Y':
            case 'Z':
            case 'a':
            case 'b':
            case 'c':
            case 'd':
            case 'e':
            case 'f':
            case 'g':
            case 'h':
            case 'i':
            case 'j':
            case 'k':
            case 'l':
            case 'm':
            case 'n':
            case 'o':
            case 'p':
            case 'q':
            case 'r':
            case 's':
            case 't':
            case 'u':
            case 'v':
            case 'w':
            case 'x':
            case 'y':
            case 'z': {
                alt3 = 17;
            }
                break;
            case '*': {
                alt3 = 19;
            }
                break;
            case ' ': {
                alt3 = 20;
            }
                break;
            default:
                NoViableAltException nvae = new NoViableAltException(
                    "1:1: Tokens : ( T10 | T11 | T12 | T13 | T14 | T15 | T16 | T17 | T18 | T19 | T20 | T21 | T22 | T23 | QUOTED_STRING | DIGIT | ALPHA | DOTSTAR | STAR | WS );",
                    3, 0, input);

                throw nvae;
        }

        switch (alt3) {
            case 1: {
                mT10();

            }
                break;
            case 2: {
                mT11();

            }
                break;
            case 3: {
                mT12();

            }
                break;
            case 4: {
                mT13();

            }
                break;
            case 5: {
                mT14();

            }
                break;
            case 6: {
                mT15();

            }
                break;
            case 7: {
                mT16();

            }
                break;
            case 8: {
                mT17();

            }
                break;
            case 9: {
                mT18();

            }
                break;
            case 10: {
                mT19();

            }
                break;
            case 11: {
                mT20();

            }
                break;
            case 12: {
                mT21();

            }
                break;
            case 13: {
                mT22();

            }
                break;
            case 14: {
                mT23();

            }
                break;
            case 15: {
                mQUOTED_STRING();

            }
                break;
            case 16: {
                mDIGIT();

            }
                break;
            case 17: {
                mALPHA();

            }
                break;
            case 18: {
                mDOTSTAR();

            }
                break;
            case 19: {
                mSTAR();

            }
                break;
            case 20: {
                mWS();

            }
                break;

        }

    }

}
