@ECHO OFF
IF "%OS%" == "Windows_NT" SETLOCAL

IF NOT "%JAVA_HOME%" == "" goto JavaHomeSet
echo The JAVA_HOME environment variable is not defined
GOTO:EOF

:JavaHomeSet

SET SCRIPT_DIR=%~dp0%
CALL "%SCRIPT_DIR%"setupClasspath.bat

SET JMXPORT=9875
SET KEYSTOREPASSWORD=changeit
SET CONFIG_DIR=%SCRIPT_DIR%..\config

:Loop
IF "%~1"=="" GOTO Continue
IF "%~1"=="-debug" CALL :handleDebug %2
IF "%~1"=="-suspend" CALL :handleSuspend
IF "%~1"=="-jmxport" CALL :handleJmxPort %2
IF "%~1"=="-jmxusers" CALL :handleJmxUsersPath %2
IF "%~1"=="-keystore" CALL :handleKeystorePath %2
IF "%~1"=="-keystorePassword" CALL :handleKeystorePassword %2
IF "%~1"=="-clean" CALL :handleClean
IF "%~1"=="-configDir" CALL :handleConfigDir %2

SHIFT
GOTO Loop

:handleDebug
SET DEBUGFLAG=debug
SET DEBUGPORT=8000
SET SUSPENDFLAG=n
IF "%~1"=="" GOTO:EOF
SET NEXTPARAM=%1
IF NOT "%NEXTPARAM:~0,1%"=="-" CALL :handleDebugPort %1
GOTO:EOF

:handleSuspend
SET SUSPENDFLAG=y
SHIFT
GOTO:EOF

:handleDebugPort
SET DEBUGPORT=%~1
SHIFT
GOTO:EOF

:handleJmxPort
SET JMXPORT=%~1
SHIFT
GOTO:EOF

:handleJmxUsersPath
SET JMXUSERSPATH=%~1
SHIFT
GOTO:EOF

:handleKeystorePath
SET KEYSTOREPATH=%~1
SHIFT
GOTO:EOF

:handleKeystorePassword
SET KEYSTOREPASSWORD=%~1
SHIFT
GOTO:EOF

:handleClean
SET APP_OPTS=%APP_OPTS% -Dcom.springsource.server.clean=true
GOTO:EOF

:handleConfigDir
SET CONFIG_DIR=%~1
SHIFT
GOTO:EOF

:Continue
IF NOT "%DEBUGFLAG%"=="" SET DEBUG_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,address=%DEBUGPORT%,server=y,suspend=%SUSPENDFLAG%

IF NOT "%CONFIG_DIR:~1,2%"==":\" SET CONFIG_DIR=%SCRIPT_DIR%..\%CONFIG_DIR%

IF "%JMXUSERSPATH%"=="" SET JMXUSERSPATH=%CONFIG_DIR%\control\jmx-users.properties
IF "%KEYSTOREPATH%"=="" SET KEYSTOREPATH=%CONFIG_DIR%\control\keystore

SET JMX_OPTS=%JMX_OPTS% -Dcom.sun.management.jmxremote.port=%JMXPORT% -Dcom.sun.management.jmxremote.authenticate -Dcom.sun.management.jmxremote.password.file="%JMXUSERSPATH%" -Djavax.net.ssl.keyStore="%KEYSTOREPATH%" -Djavax.net.ssl.keyStorePassword=%KEYSTOREPASSWORD% -Dcom.sun.management.jmxremote.ssl=true -Dcom.sun.management.jmxremote.ssl.need.client.auth=false
 
"%JAVA_HOME%"\bin\java %JAVA_OPTS% %APP_OPTS% %DEBUG_OPTS% %JMX_OPTS% %CLEAN% -Dcom.springsource.server.home="%SCRIPT_DIR%.." -Dcom.springsource.server.configDir="%CONFIG_DIR%" -Djava.io.tmpdir="%SCRIPT_DIR%..\work\tmp" -classpath "%CLASSPATH%" com.springsource.server.kernel.bootstrap.Bootstrap
