/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.bootstrap;


/**
 * Custom {@link RuntimeException} for any errors encountered while parsing or loading the
 * {@link BootstrapConfiguration}.
 * 
 * @author Sam Brannen
 * @since 1.0
 */
public class BootstrapConfigurationException extends RuntimeException {

    private static final long serialVersionUID = -8913102358860136238L;

    /**
     * @see RuntimeException#RuntimeException(String)
     */
    public BootstrapConfigurationException(String message) {
        super(message);
    }

    /**
     * @see RuntimeException#RuntimeException(String, Throwable)
     */
    public BootstrapConfigurationException(String message, Throwable cause) {
        super(message, cause);
    }

}
