/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.config.core;

import com.springsource.server.serviceability.ffdc.FatalServerException;

/**
 * Signals a fatal error in the configuration subsystem. <p/>
 * 
 * <strong>Concurrent Semantics</strong><br />
 * 
 * Threadsafe.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
public class FatalConfigurationException extends FatalServerException {

    private static final long serialVersionUID = 2228110030372206427L;

    /**
     * Creates a new <code>FatalConfigurationException</code>.
     * 
     * @param message the error message.
     */
    public FatalConfigurationException(String message) {
        super(message);
    }

    /**
     * Creates a new <code>FatalConfigurationException</code>.
     * 
     * @param message the error message.
     * @param cause the root cause.
     */
    public FatalConfigurationException(String message, Throwable cause) {
        super(message, cause);
    }

}
