/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.config.core.internal.validate;

import org.antlr.runtime.CharStream;
import org.antlr.runtime.EarlyExitException;
import org.antlr.runtime.Lexer;
import org.antlr.runtime.MismatchedSetException;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.RecognitionException;

public class EngineConfigPointSchemaLexer extends Lexer {

    public static final int VERG = 25;

    public static final int NUMBER = 31;

    public static final int T36 = 36;

    public static final int T35 = 35;

    public static final int T45 = 45;

    public static final int MAPSCHEMA = 5;

    public static final int VERSIONRANGE = 22;

    public static final int INTEGER = 12;

    public static final int T37 = 37;

    public static final int T51 = 51;

    public static final int VERSION = 21;

    public static final int LISTSCHEMA = 7;

    public static final int T46 = 46;

    public static final int DIGIT = 30;

    public static final int T38 = 38;

    public static final int POSITIVE = 20;

    public static final int INTGE = 14;

    public static final int T41 = 41;

    public static final int VERGE = 24;

    public static final int VERL = 27;

    public static final int T39 = 39;

    public static final int ENUM = 11;

    public static final int T44 = 44;

    public static final int T50 = 50;

    public static final int ANYSTRING = 10;

    public static final int WS = 34;

    public static final int ALPHA = 29;

    public static final int T43 = 43;

    public static final int T42 = 42;

    public static final int T40 = 40;

    public static final int COMMENT = 32;

    public static final int LINE_COMMENT = 33;

    public static final int NEGATIVE = 19;

    public static final int INTEGERRANGE = 13;

    public static final int ConfigPointSchema = 4;

    public static final int VERLE = 26;

    public static final int T48 = 48;

    public static final int STRINGSCHEMA = 9;

    public static final int INTLE = 16;

    public static final int EOF = -1;

    public static final int KEY = 8;

    public static final int INTL = 17;

    public static final int T47 = 47;

    public static final int MAPLETSCHEMA = 6;

    public static final int Tokens = 53;

    public static final int INTG = 15;

    public static final int SIGNED = 18;

    public static final int T49 = 49;

    public static final int IDENTIFIER = 28;

    public static final int T52 = 52;

    public static final int VERSIONVALUE = 23;

    public EngineConfigPointSchemaLexer() {
        ;
    }

    public EngineConfigPointSchemaLexer(CharStream input) {
        super(input);
    }

    @Override public String getGrammarFileName() {
        return "/Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g";
    }

    // $ANTLR start T35
    public final void mT35() throws RecognitionException {
        try {
            int _type = T35;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:6:5:
            // ( ':' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:6:7:
            // ':'
            {
                match(':');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T35

    // $ANTLR start T36
    public final void mT36() throws RecognitionException {
        try {
            int _type = T36;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:7:5:
            // ( '{' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:7:7:
            // '{'
            {
                match('{');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T36

    // $ANTLR start T37
    public final void mT37() throws RecognitionException {
        try {
            int _type = T37;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:8:5:
            // ( ',' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:8:7:
            // ','
            {
                match(',');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T37

    // $ANTLR start T38
    public final void mT38() throws RecognitionException {
        try {
            int _type = T38;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:9:5:
            // ( '}' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:9:7:
            // '}'
            {
                match('}');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T38

    // $ANTLR start T39
    public final void mT39() throws RecognitionException {
        try {
            int _type = T39;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:10:5:
            // ( '[' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:10:7:
            // '['
            {
                match('[');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T39

    // $ANTLR start T40
    public final void mT40() throws RecognitionException {
        try {
            int _type = T40;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:11:5:
            // ( ']' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:11:7:
            // ']'
            {
                match(']');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T40

    // $ANTLR start T41
    public final void mT41() throws RecognitionException {
        try {
            int _type = T41;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:12:5:
            // ( 'String' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:12:7:
            // 'String'
            {
                match("String");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T41

    // $ANTLR start T42
    public final void mT42() throws RecognitionException {
        try {
            int _type = T42;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:13:5:
            // ( 'string' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:13:7:
            // 'string'
            {
                match("string");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T42

    // $ANTLR start T43
    public final void mT43() throws RecognitionException {
        try {
            int _type = T43;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:14:5:
            // ( 'Enumeration' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:14:7:
            // 'Enumeration'
            {
                match("Enumeration");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T43

    // $ANTLR start T44
    public final void mT44() throws RecognitionException {
        try {
            int _type = T44;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:15:5:
            // ( 'enumeration' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:15:7:
            // 'enumeration'
            {
                match("enumeration");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T44

    // $ANTLR start T45
    public final void mT45() throws RecognitionException {
        try {
            int _type = T45;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:16:5:
            // ( 'Int' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:16:7:
            // 'Int'
            {
                match("Int");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T45

    // $ANTLR start T46
    public final void mT46() throws RecognitionException {
        try {
            int _type = T46;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:17:5:
            // ( 'int' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:17:7:
            // 'int'
            {
                match("int");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T46

    // $ANTLR start T47
    public final void mT47() throws RecognitionException {
        try {
            int _type = T47;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:18:5:
            // ( '-' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:18:7:
            // '-'
            {
                match('-');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T47

    // $ANTLR start T48
    public final void mT48() throws RecognitionException {
        try {
            int _type = T48;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:19:5:
            // ( '(' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:19:7:
            // '('
            {
                match('(');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T48

    // $ANTLR start T49
    public final void mT49() throws RecognitionException {
        try {
            int _type = T49;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:20:5:
            // ( ')' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:20:7:
            // ')'
            {
                match(')');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T49

    // $ANTLR start T50
    public final void mT50() throws RecognitionException {
        try {
            int _type = T50;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:21:5:
            // ( 'versionNumber' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:21:7:
            // 'versionNumber'
            {
                match("versionNumber");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T50

    // $ANTLR start T51
    public final void mT51() throws RecognitionException {
        try {
            int _type = T51;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:22:5:
            // ( 'VersionNumber' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:22:7:
            // 'VersionNumber'
            {
                match("VersionNumber");

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T51

    // $ANTLR start T52
    public final void mT52() throws RecognitionException {
        try {
            int _type = T52;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:23:5:
            // ( '.' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:23:7:
            // '.'
            {
                match('.');

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end T52

    // $ANTLR start IDENTIFIER
    public final void mIDENTIFIER() throws RecognitionException {
        try {
            int _type = IDENTIFIER;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:87:2:
            // ( ( ALPHA | '_' ) ( ALPHA | '_' | DIGIT )* )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:87:4:
            // ( ALPHA | '_' ) ( ALPHA | '_' | DIGIT )*
            {
                if (this.input.LA(1) >= 'A' && this.input.LA(1) <= 'Z' || this.input.LA(1) == '_' || this.input.LA(1) >= 'a'
                    && this.input.LA(1) <= 'z') {
                    this.input.consume();

                } else {
                    MismatchedSetException mse = new MismatchedSetException(null, this.input);
                    recover(mse);
                    throw mse;
                }

                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:87:20:
                // ( ALPHA | '_' | DIGIT )*
                loop1: do {
                    int alt1 = 2;
                    int LA1_0 = this.input.LA(1);

                    if (LA1_0 >= '0' && LA1_0 <= '9' || LA1_0 >= 'A' && LA1_0 <= 'Z' || LA1_0 == '_' || LA1_0 >= 'a' && LA1_0 <= 'z') {
                        alt1 = 1;
                    }

                    switch (alt1) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:
                        {
                            if (this.input.LA(1) >= '0' && this.input.LA(1) <= '9' || this.input.LA(1) >= 'A' && this.input.LA(1) <= 'Z'
                                || this.input.LA(1) == '_' || this.input.LA(1) >= 'a' && this.input.LA(1) <= 'z') {
                                this.input.consume();

                            } else {
                                MismatchedSetException mse = new MismatchedSetException(null, this.input);
                                recover(mse);
                                throw mse;
                            }

                        }
                            break;

                        default:
                            break loop1;
                    }
                } while (true);

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end IDENTIFIER

    // $ANTLR start NUMBER
    public final void mNUMBER() throws RecognitionException {
        try {
            int _type = NUMBER;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:124:8:
            // ( DIGIT ( DIGIT )* )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:124:10:
            // DIGIT ( DIGIT )*
            {
                mDIGIT();
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:124:16:
                // ( DIGIT )*
                loop2: do {
                    int alt2 = 2;
                    int LA2_0 = this.input.LA(1);

                    if (LA2_0 >= '0' && LA2_0 <= '9') {
                        alt2 = 1;
                    }

                    switch (alt2) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:124:18:
                            // DIGIT
                        {
                            mDIGIT();

                        }
                            break;

                        default:
                            break loop2;
                    }
                } while (true);

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end NUMBER

    // $ANTLR start ALPHA
    public final void mALPHA() throws RecognitionException {
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:128:7:
            // ( 'a' .. 'z' | 'A' .. 'Z' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:
            {
                if (this.input.LA(1) >= 'A' && this.input.LA(1) <= 'Z' || this.input.LA(1) >= 'a' && this.input.LA(1) <= 'z') {
                    this.input.consume();

                } else {
                    MismatchedSetException mse = new MismatchedSetException(null, this.input);
                    recover(mse);
                    throw mse;
                }

            }

        } finally {
        }
    }

    // $ANTLR end ALPHA

    // $ANTLR start DIGIT
    public final void mDIGIT() throws RecognitionException {
        try {
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:132:7:
            // ( '0' .. '9' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:132:9:
            // '0' .. '9'
            {
                matchRange('0', '9');

            }

        } finally {
        }
    }

    // $ANTLR end DIGIT

    // $ANTLR start COMMENT
    public final void mCOMMENT() throws RecognitionException {
        try {
            int _type = COMMENT;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:135:9:
            // ( '/*' ( . )* '*/' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:135:12:
            // '/*' ( . )* '*/'
            {
                match("/*");

                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:135:17:
                // ( . )*
                loop3: do {
                    int alt3 = 2;
                    int LA3_0 = this.input.LA(1);

                    if (LA3_0 == '*') {
                        int LA3_1 = this.input.LA(2);

                        if (LA3_1 == '/') {
                            alt3 = 2;
                        } else if (LA3_1 >= '\u0000' && LA3_1 <= '.' || LA3_1 >= '0' && LA3_1 <= '\uFFFE') {
                            alt3 = 1;
                        }

                    } else if (LA3_0 >= '\u0000' && LA3_0 <= ')' || LA3_0 >= '+' && LA3_0 <= '\uFFFE') {
                        alt3 = 1;
                    }

                    switch (alt3) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:135:17:
                            // .
                        {
                            matchAny();

                        }
                            break;

                        default:
                            break loop3;
                    }
                } while (true);

                match("*/");

                skip();

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end COMMENT

    // $ANTLR start LINE_COMMENT
    public final void mLINE_COMMENT() throws RecognitionException {
        try {
            int _type = LINE_COMMENT;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:139:2:
            // ( '//' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n' )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:139:4:
            // '//' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n'
            {
                match("//");

                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:139:9:
                // (~ ( '\\n' | '\\r' ) )*
                loop4: do {
                    int alt4 = 2;
                    int LA4_0 = this.input.LA(1);

                    if (LA4_0 >= '\u0000' && LA4_0 <= '\t' || LA4_0 >= '\u000B' && LA4_0 <= '\f' || LA4_0 >= '\u000E' && LA4_0 <= '\uFFFE') {
                        alt4 = 1;
                    }

                    switch (alt4) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:139:9:
                            // ~ ( '\\n' | '\\r' )
                        {
                            if (this.input.LA(1) >= '\u0000' && this.input.LA(1) <= '\t' || this.input.LA(1) >= '\u000B' && this.input.LA(1) <= '\f'
                                || this.input.LA(1) >= '\u000E' && this.input.LA(1) <= '\uFFFE') {
                                this.input.consume();

                            } else {
                                MismatchedSetException mse = new MismatchedSetException(null, this.input);
                                recover(mse);
                                throw mse;
                            }

                        }
                            break;

                        default:
                            break loop4;
                    }
                } while (true);

                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:139:27:
                // ( '\\r' )?
                int alt5 = 2;
                int LA5_0 = this.input.LA(1);

                if (LA5_0 == '\r') {
                    alt5 = 1;
                }
                switch (alt5) {
                    case 1:
                        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:139:27:
                        // '\\r'
                    {
                        match('\r');

                    }
                        break;

                }

                match('\n');
                skip();

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end LINE_COMMENT

    // $ANTLR start WS
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:143:2:
            // ( ( ' ' | '\\n' | '\\r' | '\\t' )+ )
            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:143:4:
            // ( ' ' | '\\n' | '\\r' | '\\t' )+
            {
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:143:4:
                // ( ' ' | '\\n' | '\\r' | '\\t' )+
                int cnt6 = 0;
                loop6: do {
                    int alt6 = 2;
                    int LA6_0 = this.input.LA(1);

                    if (LA6_0 >= '\t' && LA6_0 <= '\n' || LA6_0 == '\r' || LA6_0 == ' ') {
                        alt6 = 1;
                    }

                    switch (alt6) {
                        case 1:
                            // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:
                        {
                            if (this.input.LA(1) >= '\t' && this.input.LA(1) <= '\n' || this.input.LA(1) == '\r' || this.input.LA(1) == ' ') {
                                this.input.consume();

                            } else {
                                MismatchedSetException mse = new MismatchedSetException(null, this.input);
                                recover(mse);
                                throw mse;
                            }

                        }
                            break;

                        default:
                            if (cnt6 >= 1) {
                                break loop6;
                            }
                            EarlyExitException eee = new EarlyExitException(6, this.input);
                            throw eee;
                    }
                    cnt6++;
                } while (true);

                skip();

            }

            this.type = _type;
        } finally {
        }
    }

    // $ANTLR end WS

    @Override public void mTokens() throws RecognitionException {
        // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:8:
        // ( T35 | T36 | T37 | T38 | T39 | T40 | T41 | T42 | T43 | T44 | T45 | T46 | T47 | T48 | T49 | T50 | T51 | T52 |
        // IDENTIFIER | NUMBER | COMMENT | LINE_COMMENT | WS )
        int alt7 = 23;
        switch (this.input.LA(1)) {
            case ':': {
                alt7 = 1;
            }
                break;
            case '{': {
                alt7 = 2;
            }
                break;
            case ',': {
                alt7 = 3;
            }
                break;
            case '}': {
                alt7 = 4;
            }
                break;
            case '[': {
                alt7 = 5;
            }
                break;
            case ']': {
                alt7 = 6;
            }
                break;
            case 'S': {
                int LA7_7 = this.input.LA(2);

                if (LA7_7 == 't') {
                    int LA7_23 = this.input.LA(3);

                    if (LA7_23 == 'r') {
                        int LA7_33 = this.input.LA(4);

                        if (LA7_33 == 'i') {
                            int LA7_41 = this.input.LA(5);

                            if (LA7_41 == 'n') {
                                int LA7_49 = this.input.LA(6);

                                if (LA7_49 == 'g') {
                                    int LA7_55 = this.input.LA(7);

                                    if (LA7_55 >= '0' && LA7_55 <= '9' || LA7_55 >= 'A' && LA7_55 <= 'Z' || LA7_55 == '_' || LA7_55 >= 'a'
                                        && LA7_55 <= 'z') {
                                        alt7 = 19;
                                    } else {
                                        alt7 = 7;
                                    }
                                } else {
                                    alt7 = 19;
                                }
                            } else {
                                alt7 = 19;
                            }
                        } else {
                            alt7 = 19;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case 's': {
                int LA7_8 = this.input.LA(2);

                if (LA7_8 == 't') {
                    int LA7_24 = this.input.LA(3);

                    if (LA7_24 == 'r') {
                        int LA7_34 = this.input.LA(4);

                        if (LA7_34 == 'i') {
                            int LA7_42 = this.input.LA(5);

                            if (LA7_42 == 'n') {
                                int LA7_50 = this.input.LA(6);

                                if (LA7_50 == 'g') {
                                    int LA7_56 = this.input.LA(7);

                                    if (LA7_56 >= '0' && LA7_56 <= '9' || LA7_56 >= 'A' && LA7_56 <= 'Z' || LA7_56 == '_' || LA7_56 >= 'a'
                                        && LA7_56 <= 'z') {
                                        alt7 = 19;
                                    } else {
                                        alt7 = 8;
                                    }
                                } else {
                                    alt7 = 19;
                                }
                            } else {
                                alt7 = 19;
                            }
                        } else {
                            alt7 = 19;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case 'E': {
                int LA7_9 = this.input.LA(2);

                if (LA7_9 == 'n') {
                    int LA7_25 = this.input.LA(3);

                    if (LA7_25 == 'u') {
                        int LA7_35 = this.input.LA(4);

                        if (LA7_35 == 'm') {
                            int LA7_43 = this.input.LA(5);

                            if (LA7_43 == 'e') {
                                int LA7_51 = this.input.LA(6);

                                if (LA7_51 == 'r') {
                                    int LA7_57 = this.input.LA(7);

                                    if (LA7_57 == 'a') {
                                        int LA7_63 = this.input.LA(8);

                                        if (LA7_63 == 't') {
                                            int LA7_67 = this.input.LA(9);

                                            if (LA7_67 == 'i') {
                                                int LA7_71 = this.input.LA(10);

                                                if (LA7_71 == 'o') {
                                                    int LA7_75 = this.input.LA(11);

                                                    if (LA7_75 == 'n') {
                                                        int LA7_79 = this.input.LA(12);

                                                        if (LA7_79 >= '0' && LA7_79 <= '9' || LA7_79 >= 'A' && LA7_79 <= 'Z' || LA7_79 == '_'
                                                            || LA7_79 >= 'a' && LA7_79 <= 'z') {
                                                            alt7 = 19;
                                                        } else {
                                                            alt7 = 9;
                                                        }
                                                    } else {
                                                        alt7 = 19;
                                                    }
                                                } else {
                                                    alt7 = 19;
                                                }
                                            } else {
                                                alt7 = 19;
                                            }
                                        } else {
                                            alt7 = 19;
                                        }
                                    } else {
                                        alt7 = 19;
                                    }
                                } else {
                                    alt7 = 19;
                                }
                            } else {
                                alt7 = 19;
                            }
                        } else {
                            alt7 = 19;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case 'e': {
                int LA7_10 = this.input.LA(2);

                if (LA7_10 == 'n') {
                    int LA7_26 = this.input.LA(3);

                    if (LA7_26 == 'u') {
                        int LA7_36 = this.input.LA(4);

                        if (LA7_36 == 'm') {
                            int LA7_44 = this.input.LA(5);

                            if (LA7_44 == 'e') {
                                int LA7_52 = this.input.LA(6);

                                if (LA7_52 == 'r') {
                                    int LA7_58 = this.input.LA(7);

                                    if (LA7_58 == 'a') {
                                        int LA7_64 = this.input.LA(8);

                                        if (LA7_64 == 't') {
                                            int LA7_68 = this.input.LA(9);

                                            if (LA7_68 == 'i') {
                                                int LA7_72 = this.input.LA(10);

                                                if (LA7_72 == 'o') {
                                                    int LA7_76 = this.input.LA(11);

                                                    if (LA7_76 == 'n') {
                                                        int LA7_80 = this.input.LA(12);

                                                        if (LA7_80 >= '0' && LA7_80 <= '9' || LA7_80 >= 'A' && LA7_80 <= 'Z' || LA7_80 == '_'
                                                            || LA7_80 >= 'a' && LA7_80 <= 'z') {
                                                            alt7 = 19;
                                                        } else {
                                                            alt7 = 10;
                                                        }
                                                    } else {
                                                        alt7 = 19;
                                                    }
                                                } else {
                                                    alt7 = 19;
                                                }
                                            } else {
                                                alt7 = 19;
                                            }
                                        } else {
                                            alt7 = 19;
                                        }
                                    } else {
                                        alt7 = 19;
                                    }
                                } else {
                                    alt7 = 19;
                                }
                            } else {
                                alt7 = 19;
                            }
                        } else {
                            alt7 = 19;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case 'I': {
                int LA7_11 = this.input.LA(2);

                if (LA7_11 == 'n') {
                    int LA7_27 = this.input.LA(3);

                    if (LA7_27 == 't') {
                        int LA7_37 = this.input.LA(4);

                        if (LA7_37 >= '0' && LA7_37 <= '9' || LA7_37 >= 'A' && LA7_37 <= 'Z' || LA7_37 == '_' || LA7_37 >= 'a' && LA7_37 <= 'z') {
                            alt7 = 19;
                        } else {
                            alt7 = 11;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case 'i': {
                int LA7_12 = this.input.LA(2);

                if (LA7_12 == 'n') {
                    int LA7_28 = this.input.LA(3);

                    if (LA7_28 == 't') {
                        int LA7_38 = this.input.LA(4);

                        if (LA7_38 >= '0' && LA7_38 <= '9' || LA7_38 >= 'A' && LA7_38 <= 'Z' || LA7_38 == '_' || LA7_38 >= 'a' && LA7_38 <= 'z') {
                            alt7 = 19;
                        } else {
                            alt7 = 12;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case '-': {
                alt7 = 13;
            }
                break;
            case '(': {
                alt7 = 14;
            }
                break;
            case ')': {
                alt7 = 15;
            }
                break;
            case 'v': {
                int LA7_16 = this.input.LA(2);

                if (LA7_16 == 'e') {
                    int LA7_29 = this.input.LA(3);

                    if (LA7_29 == 'r') {
                        int LA7_39 = this.input.LA(4);

                        if (LA7_39 == 's') {
                            int LA7_47 = this.input.LA(5);

                            if (LA7_47 == 'i') {
                                int LA7_53 = this.input.LA(6);

                                if (LA7_53 == 'o') {
                                    int LA7_59 = this.input.LA(7);

                                    if (LA7_59 == 'n') {
                                        int LA7_65 = this.input.LA(8);

                                        if (LA7_65 == 'N') {
                                            int LA7_69 = this.input.LA(9);

                                            if (LA7_69 == 'u') {
                                                int LA7_73 = this.input.LA(10);

                                                if (LA7_73 == 'm') {
                                                    int LA7_77 = this.input.LA(11);

                                                    if (LA7_77 == 'b') {
                                                        int LA7_81 = this.input.LA(12);

                                                        if (LA7_81 == 'e') {
                                                            int LA7_85 = this.input.LA(13);

                                                            if (LA7_85 == 'r') {
                                                                int LA7_87 = this.input.LA(14);

                                                                if (LA7_87 >= '0' && LA7_87 <= '9' || LA7_87 >= 'A' && LA7_87 <= 'Z' || LA7_87 == '_'
                                                                    || LA7_87 >= 'a' && LA7_87 <= 'z') {
                                                                    alt7 = 19;
                                                                } else {
                                                                    alt7 = 16;
                                                                }
                                                            } else {
                                                                alt7 = 19;
                                                            }
                                                        } else {
                                                            alt7 = 19;
                                                        }
                                                    } else {
                                                        alt7 = 19;
                                                    }
                                                } else {
                                                    alt7 = 19;
                                                }
                                            } else {
                                                alt7 = 19;
                                            }
                                        } else {
                                            alt7 = 19;
                                        }
                                    } else {
                                        alt7 = 19;
                                    }
                                } else {
                                    alt7 = 19;
                                }
                            } else {
                                alt7 = 19;
                            }
                        } else {
                            alt7 = 19;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case 'V': {
                int LA7_17 = this.input.LA(2);

                if (LA7_17 == 'e') {
                    int LA7_30 = this.input.LA(3);

                    if (LA7_30 == 'r') {
                        int LA7_40 = this.input.LA(4);

                        if (LA7_40 == 's') {
                            int LA7_48 = this.input.LA(5);

                            if (LA7_48 == 'i') {
                                int LA7_54 = this.input.LA(6);

                                if (LA7_54 == 'o') {
                                    int LA7_60 = this.input.LA(7);

                                    if (LA7_60 == 'n') {
                                        int LA7_66 = this.input.LA(8);

                                        if (LA7_66 == 'N') {
                                            int LA7_70 = this.input.LA(9);

                                            if (LA7_70 == 'u') {
                                                int LA7_74 = this.input.LA(10);

                                                if (LA7_74 == 'm') {
                                                    int LA7_78 = this.input.LA(11);

                                                    if (LA7_78 == 'b') {
                                                        int LA7_82 = this.input.LA(12);

                                                        if (LA7_82 == 'e') {
                                                            int LA7_86 = this.input.LA(13);

                                                            if (LA7_86 == 'r') {
                                                                int LA7_88 = this.input.LA(14);

                                                                if (LA7_88 >= '0' && LA7_88 <= '9' || LA7_88 >= 'A' && LA7_88 <= 'Z' || LA7_88 == '_'
                                                                    || LA7_88 >= 'a' && LA7_88 <= 'z') {
                                                                    alt7 = 19;
                                                                } else {
                                                                    alt7 = 17;
                                                                }
                                                            } else {
                                                                alt7 = 19;
                                                            }
                                                        } else {
                                                            alt7 = 19;
                                                        }
                                                    } else {
                                                        alt7 = 19;
                                                    }
                                                } else {
                                                    alt7 = 19;
                                                }
                                            } else {
                                                alt7 = 19;
                                            }
                                        } else {
                                            alt7 = 19;
                                        }
                                    } else {
                                        alt7 = 19;
                                    }
                                } else {
                                    alt7 = 19;
                                }
                            } else {
                                alt7 = 19;
                            }
                        } else {
                            alt7 = 19;
                        }
                    } else {
                        alt7 = 19;
                    }
                } else {
                    alt7 = 19;
                }
            }
                break;
            case '.': {
                alt7 = 18;
            }
                break;
            case 'A':
            case 'B':
            case 'C':
            case 'D':
            case 'F':
            case 'G':
            case 'H':
            case 'J':
            case 'K':
            case 'L':
            case 'M':
            case 'N':
            case 'O':
            case 'P':
            case 'Q':
            case 'R':
            case 'T':
            case 'U':
            case 'W':
            case 'X':
            case 'Y':
            case 'Z':
            case '_':
            case 'a':
            case 'b':
            case 'c':
            case 'd':
            case 'f':
            case 'g':
            case 'h':
            case 'j':
            case 'k':
            case 'l':
            case 'm':
            case 'n':
            case 'o':
            case 'p':
            case 'q':
            case 'r':
            case 't':
            case 'u':
            case 'w':
            case 'x':
            case 'y':
            case 'z': {
                alt7 = 19;
            }
                break;
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9': {
                alt7 = 20;
            }
                break;
            case '/': {
                int LA7_21 = this.input.LA(2);

                if (LA7_21 == '/') {
                    alt7 = 22;
                } else if (LA7_21 == '*') {
                    alt7 = 21;
                } else {
                    NoViableAltException nvae = new NoViableAltException(
                        "1:1: Tokens : ( T35 | T36 | T37 | T38 | T39 | T40 | T41 | T42 | T43 | T44 | T45 | T46 | T47 | T48 | T49 | T50 | T51 | T52 | IDENTIFIER | NUMBER | COMMENT | LINE_COMMENT | WS );",
                        7, 21, this.input);

                    throw nvae;
                }
            }
                break;
            case '\t':
            case '\n':
            case '\r':
            case ' ': {
                alt7 = 23;
            }
                break;
            default:
                NoViableAltException nvae = new NoViableAltException(
                    "1:1: Tokens : ( T35 | T36 | T37 | T38 | T39 | T40 | T41 | T42 | T43 | T44 | T45 | T46 | T47 | T48 | T49 | T50 | T51 | T52 | IDENTIFIER | NUMBER | COMMENT | LINE_COMMENT | WS );",
                    7, 0, this.input);

                throw nvae;
        }

        switch (alt7) {
            case 1:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:10:
                // T35
            {
                mT35();

            }
                break;
            case 2:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:14:
                // T36
            {
                mT36();

            }
                break;
            case 3:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:18:
                // T37
            {
                mT37();

            }
                break;
            case 4:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:22:
                // T38
            {
                mT38();

            }
                break;
            case 5:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:26:
                // T39
            {
                mT39();

            }
                break;
            case 6:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:30:
                // T40
            {
                mT40();

            }
                break;
            case 7:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:34:
                // T41
            {
                mT41();

            }
                break;
            case 8:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:38:
                // T42
            {
                mT42();

            }
                break;
            case 9:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:42:
                // T43
            {
                mT43();

            }
                break;
            case 10:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:46:
                // T44
            {
                mT44();

            }
                break;
            case 11:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:50:
                // T45
            {
                mT45();

            }
                break;
            case 12:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:54:
                // T46
            {
                mT46();

            }
                break;
            case 13:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:58:
                // T47
            {
                mT47();

            }
                break;
            case 14:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:62:
                // T48
            {
                mT48();

            }
                break;
            case 15:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:66:
                // T49
            {
                mT49();

            }
                break;
            case 16:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:70:
                // T50
            {
                mT50();

            }
                break;
            case 17:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:74:
                // T51
            {
                mT51();

            }
                break;
            case 18:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:78:
                // T52
            {
                mT52();

            }
                break;
            case 19:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:82:
                // IDENTIFIER
            {
                mIDENTIFIER();

            }
                break;
            case 20:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:93:
                // NUMBER
            {
                mNUMBER();

            }
                break;
            case 21:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:100:
                // COMMENT
            {
                mCOMMENT();

            }
                break;
            case 22:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:108:
                // LINE_COMMENT
            {
                mLINE_COMMENT();

            }
                break;
            case 23:
                // /Users/glynnormington/engine/config/com.springsource.server.config.core/src/main/java/com/springsource/engine/config/core/validate/EngineConfigPointSchema.g:1:121:
                // WS
            {
                mWS();

            }
                break;

        }

    }

}
