/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.control.core.internal;

/**
 * Constants used by the Control subsystem.
 * <p />
 *
 * <strong>Concurrent Semantics</strong><br />
 * Thread-safe.
 *
 * @author Andy Wilkinson
 * @since 1.0
 */
final class Constants {
    protected static final String CONTROL_EXPORT_DOMAIN = "com.springsource.server";
    protected static final String CONTROL_IDENTIFIER = "com.springsource.server.control";
    protected static final String CONTROL_SERVICE_PROPERTY_KEY_PREFIX = CONTROL_IDENTIFIER + ".";
    protected static final String CONTROL_SERVICE_FILTER_STRING = "(" + CONTROL_IDENTIFIER + "=true)";
}
