/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.deployer.core.internal;

import java.net.URI;
import java.util.Set;

import com.springsource.server.deployer.core.DeploymentArtefact;
import com.springsource.server.io.core.PathReference;


/**
 * {@link FileDeploymentArtefact} is a {@link DeploymentArtefact} with some restrictions for a file.
 * <p />
 *
 * <strong>Concurrent Semantics</strong><br />
 *
 * This class is thread safe.
 *
 * @author Glyn Normington
 * @since 1.0
 */
public class FileDeploymentArtefact extends AbstractDeploymentArtefact {
    
    public FileDeploymentArtefact(URI location) {
        super(location);
    }

    /** 
     * {@inheritDoc}
     */
    public Entry createDirectoryEntry(String path) throws IllegalArgumentException {
        throw new UnsupportedOperationException();
    }

    /** 
     * {@inheritDoc}
     */
    public Set<Entry> getContents() {
        throw new UnsupportedOperationException();
    }

    /** 
     * {@inheritDoc}
     */
    public Entry getEntry(String path) {
        throw new UnsupportedOperationException();
    }

    /** 
     * {@inheritDoc}
     */
    public void copy(PathReference source, String path) {
        throw new UnsupportedOperationException();
    }

}
