/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.deployer.core.internal;

import com.springsource.server.deployer.core.CompletableDeploymentContext;
import com.springsource.server.deployer.core.DeploymentContext;
import com.springsource.server.deployer.core.DeploymentContextFactory;
import com.springsource.server.deployer.core.InformedDeployable;

/**
 * {@link StandardDeploymentContextFactory} is a factory for {@link DeploymentContext DeploymentContexts}.
 * <p />
 * 
 * <strong>Concurrent Semantics</strong><br />
 * 
 * This class is thread safe.
 * 
 * @author Glyn Normington
 * @since 1.0
 */
class StandardDeploymentContextFactory implements DeploymentContextFactory {

    /**
     * {@inheritDoc}
     */
    public CompletableDeploymentContext create(InformedDeployable informedDeployable) {
        return new StandardDeploymentContext(informedDeployable);
    }

}
