/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.io.core;

import com.springsource.server.serviceability.ffdc.FatalServerException;

/**
 * Fatal IO exception.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br/>
 * 
 * Threadsafe.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
public class FatalIOException extends FatalServerException {

    private static final long serialVersionUID = 234134109809L;

    /**
     * Creates a new <code>FatalIOException</code> with the supplied reason message and cause.
     * @param message The reason message
     * @param cause The cause
     */
    public FatalIOException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Creates a new <code>FatalIOException</code> with the supplied reason message.
     * @param message The reason message
     */
    public FatalIOException(String message) {
        super(message);
    }
}
