/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.kernel.core;

import org.osgi.framework.Bundle;

/**
 * Describes an OSGi {@link Bundle}. <p/>
 * 
 * A <code>BundleDescriptor</code> accurately reflects the current state of the <code>Bundle</code> that it is
 * describing. <p/>
 * 
 * <strong>Concurrent Semantics</strong><br/>
 * 
 * Implementations <strong>must</strong> be threadsafe.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
public interface BundleDescriptor {

    /**
     * @see Bundle#getSymbolicName()
     */
    String getSymbolicName();

    /**
     * @see Bundle#getState()
     */
    int getState();

    Bundle getBundle();
}
