/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.kernel.core.internal;

import java.util.List;

import org.osgi.framework.Bundle;

import com.springsource.server.kernel.core.Subsystem;

/**
 * Standard {@link Subsystem} implementation.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br/>
 * 
 * Threadsafe.
 * 
 * @author Rob Harrop
 * @since 1.0
 */
public final class StaticSubsystem extends AbstractSubsystem {

    /**
     * Creates a new <code>StaticSubsystem</code>.
     * 
     * @param subsystemRegistry the {@link ManagedSubsystemRegistry} this subsystem is running in.
     * @param name the name of this subsystem.
     * @param bundles the bundles inside this subsystem.
     */
    public StaticSubsystem(ManagedSubsystemRegistry subsystemRegistry, String name, List<Bundle> bundles) {
        super(subsystemRegistry, name);
        setBundles(bundles);
        setInstalled();
    }

    /**
     * {@inheritDoc}
     */
    @Override protected void doStart() {

    }

}
