/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.osgi.manifest.parse;

/**
 * Signals a fatal exception in the parser subsystem.<p/>
 * 
 * <strong>Concurrent Semantics</strong><br/>
 * 
 * Threadsafe.
 * 
 * @author Christopher Frost
 * @since 1.0
 */
public class FatalParseException extends RuntimeException {

    private static final long serialVersionUID = -4743527883152311469L;

    /** 
     * Creates a new <code>FatalParseException</code> with the supplied error message.
     * 
     * @param message The exception's message
     */
    public FatalParseException(String message) {
        super(message);
    }

    /** 
     * Creates a new <code>FatalParseException</code> with the supplied error message and cause.
     * 
     * @param message The exception's message
     * @param cause The exception's cause
     */
    public FatalParseException(String message, Throwable cause) {
        super(message, cause);
    }

}
