/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.osgi.manifest.parse;

import org.antlr.runtime.CharStream;
import org.antlr.runtime.RecognitionException;

/**
 * <p>
 * 
 * </p>
 * 
 * <strong>Concurrent Semantics</strong><br />
 * 
 * TODO Document concurrent semantics of StandardOsgiHeaderLexer
 * 
 * @author Christopher Frost
 * @since 1.0
 */
public class StandardOsgiHeaderLexer extends OsgiHeaderLexer {

    private final ManifestHeaderParserErrorHandler parserErrorHandler;

    private final String headerName;

    private final String header;

    /**
     * 
     * @param parserErrorHandler
     * @param input
     * @param headerName
     */
    public StandardOsgiHeaderLexer(ManifestHeaderParserErrorHandler parserErrorHandler, CharStream input, String headerName, String header) {
        super(input);
        this.parserErrorHandler = parserErrorHandler;
        this.headerName = headerName;
        this.header = header;
    }

    /**
     * 
     * {@inheritDoc}
     */
    @Override 
    public void recover(RecognitionException re) {
        this.parserErrorHandler.recoverableError(re, this.headerName, this.header, "Lexer");
        super.input.consume();
    }

    /**
     * 
     * {@inheritDoc}
     */
    @Override 
    public void reportError(RecognitionException re) {
        this.parserErrorHandler.exitError(re, this.headerName, this.header, "Lexer");
    }

}
