/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.serviceability.output.internal;

import java.io.PrintWriter;

/**
 * 
 * @author Glyn Normington
 * @since 1.0
 * 
 */
final class ConsoleDestination extends WriterDestination {

    /**
     * Construct a destination backed by the console.
     * 
     */
    ConsoleDestination(StandardDestinationRegistry destinationRegistry) {
        super(new PrintWriter(System.out), 1, destinationRegistry);
    }
    
    /** 
     * {@inheritDoc}
     */
    public String toString(){
        return "Console Output";
    }
}
