/* 
 * This file is part of the SpringSource dm Server.
 * 
 * Copyright (C) 2008 SpringSource Inc.
 * 
 * The SpringSource dm Server is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * The SpringSource dm Server is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * the SpringSource dm Server. If not, see <http://www.gnu.org/licenses/>.
 */

package com.springsource.server.web.core;

/**
 * Collection of constants related to manifest headers for configuring web module deployment.
 * 
 * @author Sam Brannen
 * @since 1.0
 */
public final class WebManifestHeaders {

    /**
     * Web-
     */
    public static final String PREFIX = "Web-";

    /**
     * Web-ContextPath
     */
    public static final String CONTEXT_PATH = PREFIX + "ContextPath";

    /**
     * Web-DispatcherServletUrlPatterns
     */
    public static final String DISPATCHER_SERVLET_URL_PATTERNS = PREFIX + "DispatcherServletUrlPatterns";

    /**
     * Web-FilterMappings
     */
    public static final String FILTER_MAPPINGS = PREFIX + "FilterMappings";

    /**
     * Default URL patterns for the <code>DispatcherServlet</code> mappings: <code>{ &quot;*.htm&quot; }</code>.
     */
    public static final String[] DEFAULT_DISPATCHER_SERVLET_URL_PATTERNS = new String[] { "*.htm" };

    private WebManifestHeaders() {
        /* no-op */
    }

}
